SystemOrganization addCategory: #'ByteSurgeon-MW'!
SystemOrganization addCategory: #'ByteSurgeon-Tests'!
SystemOrganization addCategory: #'ByteSurgeon-Compiler'!

RBValueNode subclass: #ByteSurgeonNode
	instanceVariableNames: 'reify operation tempOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonNode methodsFor: 'visitor' stamp: 'md 4/28/2005 14:42'!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptByteSurgeonNode: self! !

!ByteSurgeonNode methodsFor: 'testing' stamp: 'md 6/21/2005 13:50'!
isMeta
	^true.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 6/21/2005 13:49'!
reify
	^reify.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 4/28/2005 14:45'!
reify: aSelector
	reify:= aSelector.! !

!ByteSurgeonNode methodsFor: 'accessing' stamp: 'md 6/16/2005 14:19'!
tempOffset
	^IRInliner new getOffsetForName: reify.! !

Object subclass: #BCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

BCounter class
	instanceVariableNames: 'count'!

!BCounter commentStamp: '<historical>' prior: 0!
A simple counter with state in the class

  BCounter reset
  BCounter inc
  BCounter count!

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:03'!
count
	^count.! !

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/22/2005 11:13'!
inc
	count := count + 1.! !

!BCounter class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:03'!
reset
	count := 0.! !

Object subclass: #BSBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!BSBenchmark class methodsFor: 'as yet unclassified' stamp: 'md 7/5/2005 14:38'!
bench
	^self new bench.! !

!BSBenchmark methodsFor: 'as yet unclassified' stamp: 'md 7/5/2005 14:43'!
bench
	| selectors tests |

	selectors := ByteSurgeonTest methodDict keys 
					select: [:each | each beginsWith: 'test' ]
					thenCollect: [:each | each asSymbol].

	tests := ByteSurgeonTest new.

	^ [selectors do: [:each | tests perform: each]] timeToRun.! !

Object subclass: #BSExamples
	instanceVariableNames: 't metaobjectaTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

BSExamples class
	instanceVariableNames: 'metaobjectaTest'!

!BSExamples commentStamp: '<historical>' prior: 0!
The TODO List for Bytesurgeon!

BSExamples subclass: #BSExamplesSub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!BSExamplesSub methodsFor: 'as yet unclassified' stamp: 'md 7/15/2005 23:12'!
bug4
	^t! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:15'!
readContext: ctxt
	self assert: ctxt selector = #instAccess.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 11:39'!
readName: sel
	self assert: sel = 't'.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 11:54'!
readObject: sel
	self assert: sel class == self.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:01'!
readSelector: sel
	self assert: sel = #instAccess.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 12:19'!
readValue: val
	self assert: val = 1.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/20/2005 21:26'!
read: offset
	self assert: offset == 1.
	^5! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 12:10'!
sendBeforeOrAfter: sel args: args to: rec
	
	self assert: ( (sel = #squared) or: [  (sel = #returnParamWith:with:with:with:with:with:with:)]).

	sel = #returnParamWith:with:with:with:with:with:with: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1 2 3 4 5 6 7)).
		(args at: 7) timesRepeat: [BCounter inc].
	].

	sel = #squared ifTrue: [
		self assert: (rec class = SmallInteger).
		self assert: (args = #()).

		rec timesRepeat: [BCounter inc].
	].

	! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:23'!
sendContext: ctx
	self assert: ctx selector = #receiverArgs2.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2005 20:36'!
sendFrom: caller to: rec selector: sel withArgs: args
	
	self assert: sel = #returnParam:.
	self assert: caller class = self.
	self assert: (rec class = self).
	self assert: (args = #(1)).

	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/24/2005 11:15'!
sendResult: anObject
	self assert: anObject == 4.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:24'!
sendSenderSelector: sel
	self assert: sel = #receiverArgs2.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 4/21/2005 14:15'!
sendSender: object
	self assert: object class = self.
	^3! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 20:10'!
sendTo: receiver selector: sel
	
	self assert: ( (sel = #returnParam:and:) or: [  (sel = #returnParam:)]).

	sel = #returnParam:and: ifTrue: [
		self assert: (receiver class = self).
	].

	sel = #returnParam: ifTrue: [
		self assert: (receiver class = self).
		^1
	].! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/5/2005 20:06'!
sendWithArgs: args 
	
	self assert: (args = #(1 2)).
	^args inject: 0 into: [:sum :each | sum := sum + each. sum]! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/13/2005 15:54'!
sendWithSelector: sel
	
	self assert: sel = #returnParam:.
	^3
! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'md 3/2/2005 12:23'!
send: sel args: args to: rec
	
	self assert: ( (sel = #returnParam:and:) or: [  (sel = #returnParam:)]).

	sel = #returnParam:and: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1 2)).
	].

	sel = #returnParam: ifTrue: [
		self assert: (rec class = self).
		self assert: (args = #(1)).
	].
	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/3/2005 17:57'!
send: sel complexArgs: args to: rec
	
	self assert: (sel = #returnParamWith:and:and:).

	self assert: (rec class = self).
	self assert: (args class = Array).
	self assert: ((args at: 1) = 8).
	self assert: ((args at: 3) == Transcript).

	^rec perform: sel withArguments: args.! !

!BSExamples class methodsFor: 'as yet unclassified' stamp: 'dr 3/3/2005 14:54'!
send: sel manyArgs: args to: rec
	
	self assert: (sel = #returnParamWith:with:with:with:with:with:with:).

	self assert: (rec class = self).
	self assert: (args class = Array).
	self assert: (args = #(1 2 3 4 5 6 7)).

	^rec perform: sel withArguments: args.! !

!BSExamples methodsFor: 'example - bugs' stamp: 'md 7/9/2005 21:26'!
bug1
	self t: 3.! !

!BSExamples methodsFor: 'example - bugs' stamp: 'ch 10/3/2005 17:28'!
bug10
	| col |
	col := OrderedCollection with: 'aaa' with: 'bbb' with: 'ccc'.
	^col 
		select: [:name | Smalltalk hasClassNamed: name]
		thenCollect: [:name | Smalltalk at: name]! !

!BSExamples methodsFor: 'example - bugs' stamp: 'md 7/15/2005 11:46'!
bug3
	t := 1.
	self t: 1 + 3.
! !

!BSExamples methodsFor: 'example - bugs' stamp: 'ch 10/3/2005 16:56'!
bug9
	| col |
	col := OrderedCollection with: 'aaa' with: 'bbb' with: 'ccc'.
	col withIndexDo: [:cat :index |
		index + 1.
	].! !

!BSExamples methodsFor: 'example - bugs' stamp: 'ch 10/5/2005 16:29'!
bug9a
	| col stream |
	col := OrderedCollection with: 'aaa' with: 'bbb' with: 'ccc'.
	stream := String new writeStream.
	col first withIndexDo:
		[:c :i|
		col do:
			[:ea |
			(ea at: i ifAbsent: []) = c ifFalse: [^nil]].
		stream nextPut: c].
	^nil! !

!BSExamples methodsFor: 'example dispatch' stamp: 'md 6/27/2005 17:09'!
exampleDispatch
	^5+5

	"reification by hand"
	"MultiSend send: #'+' , ' to: 5 withArguments: 5."! !

!BSExamples methodsFor: 'examples' stamp: 'md 4/22/2005 16:42'!
instAccess
	t := 1.
	^t.! !

!BSExamples methodsFor: 'examples' stamp: 'md 10/4/2005 16:50'!
literalVarRead
	^Object! !

!BSExamples methodsFor: 'examples' stamp: 'md 3/2/2005 12:22'!
receiverArgs
	
	^self returnParam: 1.! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/5/2005 12:24'!
receiverArgs2
	| tmp1 tmp2 tmp3 |
	tmp1 := 1.
	tmp2 := 0.
	tmp3 := tmp1 + tmp2.
	^self returnParam: tmp3 and: (1 + 1).! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 17:54'!
receiverComplexArgs
	
	^self returnParamWith: (2 raisedTo: 3) and: [17] and: Transcript.! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 14:15'!
receiverManyArgs
	
	^self returnParamWith: 1 with: 2 with: 3 with: 4 with: 5 with: 6 with: 7.! !

!BSExamples methodsFor: 'examples' stamp: 'md 9/11/2005 19:01'!
return2Squared
	^2 squared           ! !

!BSExamples methodsFor: 'examples' stamp: 'md 3/4/2005 10:53'!
returnParamWith: aNumber and: aBlock and: globalVar
	
	self assert: (aNumber = 8).
	self assert: (aBlock value = 17).
	self assert: globalVar == Transcript.

	^aBlock value! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/3/2005 14:17'!
returnParamWith: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	
	^arg1 + arg2 + arg3 + arg4 + arg5 + arg6 + arg7! !

!BSExamples methodsFor: 'examples' stamp: 'dr 4/5/2005 20:18'!
returnParam: aParam
	| tt | 
	tt := 2 squared.
	tt := aParam.
	^tt! !

!BSExamples methodsFor: 'examples' stamp: 'dr 7/16/2005 14:15'!
returnParam: aParam and: aSndParam
	^aParam + aSndParam.  ! !

!BSExamples methodsFor: 'examples' stamp: 'dr 6/7/2005 18:29'!
returnSimpleComputation
	| tmp |
	tmp := 2 raisedTo: 3.
	^tmp squared! !

!BSExamples methodsFor: 'examples' stamp: 'dr 3/5/2005 11:47'!
returnWithComplexSend
	| tt |
	tt := self returnParamWith: 1 with: 2 with: 3 with: 4 with: 5 with: 6 with: 7.
	^tt! !

!BSExamples methodsFor: 'as yet unclassified' stamp: 'md 7/10/2005 09:53'!
run
	^ 3 + 4! !

!BSExamples methodsFor: 'accessing' stamp: 'md 7/9/2005 21:25'!
t
	^t! !

!BSExamples methodsFor: 'examples' stamp: 'md 7/10/2005 09:15'!
tempAccess
	| tt |
	tt := 1.
	Object assert: true.
	^tt ! !

!BSExamples methodsFor: 'examples' stamp: 'md 11/26/2004 14:52'!
test: aParam
	^thisContext at: 1.! !

!BSExamples methodsFor: 'accessing' stamp: 'md 7/9/2005 21:25'!
t: anObject
	t := anObject.! !

Object subclass: #BSMethodWrapper
	instanceVariableNames: 'method class selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!BSMethodWrapper commentStamp: '<historical>' prior: 0!
I provide the features of MethodWrapers, but implemented by Inlining the Before/After methods

In before/after methods implemented in the Wrapper class can be called ("self something"), but
direkt instVar access should not be used. (Will not work as it would try to access instVars
of the wrappee, not the wrapper).

This does not yet wrap method in ensure block for after.



TestMethodWrapperCounter allInstances do: [:i | SystemChangeNotifier uniqueInstance noMoreNotificationsFor: i]
!

!BSMethodWrapper class methodsFor: 'instance creation' stamp: 'md 2/26/2005 16:27'!
on: aSelector inClass: aClass
	^self new class: aClass selector: aSelector.
	! !

!BSMethodWrapper methodsFor: 'before after' stamp: 'md 2/22/2005 13:35'!
afterMethod! !

!BSMethodWrapper methodsFor: 'before after' stamp: 'md 2/22/2005 13:35'!
beforeMethod! !

!BSMethodWrapper methodsFor: 'accessing' stamp: 'md 2/23/2005 12:24'!
class: aClass selector: aSelector
	class := aClass.
	selector := aSelector.! !

!BSMethodWrapper methodsFor: 'private' stamp: 'md 7/29/2005 09:34'!
inlineBeforeAfter
	"install the wrapper by inlining before/after"
	|  before after |

	before := (self class lookupSelector: #beforeMethod) ir strip.
	after := (self class lookupSelector: #afterMethod) ir strip.
	
	self replaceSelf: before.
	self replaceSelf: after.
	self method insertBefore: before startSequence after: after startSequence.! !

!BSMethodWrapper methodsFor: 'installing' stamp: 'md 2/26/2005 16:24'!
install
	"install the wrapper"
	self inlineBeforeAfter.
	self registerNotification.! !

!BSMethodWrapper methodsFor: 'accessing' stamp: 'md 2/23/2005 11:41'!
method
	^class>>selector.! !

!BSMethodWrapper methodsFor: 'change notification' stamp: 'md 2/26/2005 16:24'!
methodModified: aMethodChange
	(class = (aMethodChange environmentAt: #class)) ifFalse: [^self].
	(selector = (aMethodChange environmentAt: #selector)) ifFalse: [^self].
	self inlineBeforeAfter.! !

!BSMethodWrapper methodsFor: 'change notification' stamp: 'md 2/23/2005 11:15'!
registerNotification
	SystemChangeNotifier uniqueInstance
			notify: self
			ofSystemChangesOfItem: #method 
			change: #Modified 
			using: #methodModified:.! !

!BSMethodWrapper methodsFor: 'private' stamp: 'md 7/29/2005 09:34'!
replaceSelf: ir
	"replace self with pointer to me"
	ir allInstructions do: [:instr | instr isSelf ifTrue: [instr replaceWith: (IRInstruction pushLiteral: self)]].! !

!BSMethodWrapper methodsFor: 'installing' stamp: 'md 7/20/2005 09:21'!
uninstall
	"remove the wrapper by deregistering from change
      notification and recompiling... "
	self unregisterNotification.
	self method recompile.! !

!BSMethodWrapper methodsFor: 'change notification' stamp: 'md 7/20/2005 09:21'!
unregisterNotification
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.! !

BSMethodWrapper subclass: #TestMethodWrapperCounter
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!TestMethodWrapperCounter commentStamp: '<historical>' prior: 0!
A simple Wrapper that has state (a counter) as an instvar of the wrapper. !

!TestMethodWrapperCounter methodsFor: 'wrapper' stamp: 'md 2/24/2005 11:07'!
beforeMethod
	self inc.! !

!TestMethodWrapperCounter methodsFor: 'accessing' stamp: 'md 2/22/2005 15:15'!
counter 
	^counter.! !

!TestMethodWrapperCounter methodsFor: 'counter' stamp: 'md 2/24/2005 11:08'!
inc
	counter := counter + 1.! !

!TestMethodWrapperCounter methodsFor: 'initialize-release' stamp: 'md 2/22/2005 15:44'!
initialize
	self reset.! !

!TestMethodWrapperCounter methodsFor: 'counter' stamp: 'md 2/22/2005 15:44'!
reset
	counter := 0.! !

BSMethodWrapper subclass: #TestMethodWrapperSimple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!TestMethodWrapperSimple commentStamp: '<historical>' prior: 0!
A simple example for MethodWrappers: Use BCounter to count entry/exit.!

!TestMethodWrapperSimple methodsFor: 'before after' stamp: 'md 2/22/2005 14:27'!
afterMethod
	BCounter inc.! !

!TestMethodWrapperSimple methodsFor: 'before after' stamp: 'md 2/22/2005 14:26'!
beforeMethod
	BCounter inc.! !

Object subclass: #ByteSurgeon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

ByteSurgeon class
	instanceVariableNames: 'methods saveOriginal keepUpToDate'!

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 09:42'!
initialize
	keepUpToDate := OrderedCollection new.
	saveOriginal := OrderedCollection new.! !

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 09:53'!
keepUpToDate: aMethodOrClass
	aMethodOrClass isBehavior ifTrue: [keepUpToDate addAll: aMethodOrClass methodDict values] ifFalse: [keepUpToDate add: aMethodOrClass].
	
	
	! !

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 10:12'!
methodModified: aMethodChange
	| method |
	method := aMethodChange oldItem.
	(keepUpToDate anySatisfy: [:meth | method == meth]) ifTrue: [self halt].
	
	! !

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 09:47'!
registerNotification
	SystemChangeNotifier uniqueInstance
			notify: self
			ofSystemChangesOfItem: #method 
			change: #Modified 
			using: #methodModified:.! !

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 09:42'!
saveOriginal: aMethodOrClass
	aMethodOrClass isBehavior ifTrue: [saveOriginal addAll: aMethodOrClass methodDict values] ifFalse: [saveOriginal add: aMethodOrClass].
	
	! !

!ByteSurgeon class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 09:48'!
unregisterNotification
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.! !

Object subclass: #IRInliner
	instanceVariableNames: 'node num reifications maxTemp variables tempOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

IRInliner subclass: #IRInlinerAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!IRInlinerAccess methodsFor: 'gen' stamp: 'md 7/7/2005 17:51'!
genAccessNewValue

	self reify: #newvalue with: num.
	num := num + 1.
	^{IRInstruction storeTemp: num - 1}.! !

!IRInlinerAccess methodsFor: 'gen' stamp: 'md 7/16/2005 22:26'!
genAccessValue

	num := num + 1.
	self reify: #value with: num - 1.
	node isTempAccess ifTrue: [
		^ {
			(IRInstruction pushTemp: node number).
			(IRInstruction storeTemp: num - 1).
			(IRInstruction popTop).
		} 
	].
	^ {
		(IRInstruction pushReceiver).
		(IRInstruction pushLiteral: node number).
		(IRInstruction send: #instVarAt:).
		(IRInstruction storeTemp: num - 1).
		(IRInstruction popTop).
	}
	! !

!IRInlinerAccess methodsFor: 'gen' stamp: 'md 10/6/2005 16:17'!
genPreamble

	| statements |
	statements := IRSequence new.
	num := maxTemp + 1.

	(self shouldReify: #newvalue) ifTrue: [statements addAll: self genAccessNewValue].
	(self shouldReify: #value) ifTrue: [statements addAll: self genAccessValue].

	self additionalVars do: [:each |  
		(self shouldReify: each) ifTrue: [statements addAll: (self genAdditionalVars: each)]
	].
	^ statements.! !

!IRInlinerAccess methodsFor: 'public' stamp: 'md 7/16/2005 17:29'!
insertAfter: aString
	| instr preamble |
	
	instr := self prepareForInlining: aString. 
	preamble := self genPreamble.
	self patchInlinedCode: instr.
	node 
		addInstructionsBefore: preamble;
		addInstructionsAfter: instr.
	self 
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInlinerAccess methodsFor: 'public' stamp: 'md 7/16/2005 17:29'!
insertBefore: aString
	| instr preamble |

	instr := self prepareForInlining: aString.
	preamble := self genPreamble.
	self patchInlinedCode: instr.
	node 
		addInstructionsBefore: preamble;
		addInstructionsBefore: instr.
	self 
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInlinerAccess methodsFor: 'public' stamp: 'md 7/16/2005 17:33'!
replaceAndStore: aString
	| instr preamble |

	instr := self prepareForInlining: aString.
	preamble := self genPreamble.
	self patchInlinedCode: instr.
	node 
		addInstructionsBefore: preamble;
		addInstructionsBefore: instr.
	self
		balanceStack: instr;
		fixJumps: instr.! !

!IRInlinerAccess methodsFor: 'public' stamp: 'md 7/19/2005 16:01'!
replace: aString
	| instr preamble |

	instr := self prepareForInlining: aString.
	preamble := self genPreamble.
	self patchInlinedCode: instr.	
	node 
		addInstructionsBefore: preamble;
		replaceWithInstructions: instr.
	self
		balanceStack: instr;
		fixJumps: instr.! !

IRInliner subclass: #IRInlinerMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!IRInlinerMethod methodsFor: 'gen' stamp: 'md 7/18/2005 10:02'!
genMethodArguments
	
	| statements |
	self reify: #arguments with: num.
	statements := OrderedCollection new.

	"construct an array for all arguments and store it into a tmp var"
	statements addAll: {
		IRInstruction pushLiteralVariable: Array holder.
		IRInstruction pushLiteral: node numRargs - 1.
		IRInstruction send: #new:.
		IRInstruction storeTemp: num.				
	}.
	num := num + 1.

	"add all arguments to the array"
		(1 to: node numArgs) do: [:a |
			statements addAll: { 					
					IRInstruction pushTemp: (reifications at: #arguments).
					IRInstruction pushLiteral: a.
					IRInstruction pushTemp: a.
					IRInstruction send: #at:put:.
					IRInstruction popTop.
				}.
			self reify: (('arg', a asString) asSymbol) with: a.
			].
	^statements.! !

!IRInlinerMethod methodsFor: 'gen' stamp: 'md 7/7/2005 17:53'!
genMethodReceiver
	
	self reify: #receiver with: num.
	num := num + 1.
	^ {
		IRInstruction pushReceiver.
		IRInstruction storeTemp: num -1 .		
		IRInstruction popTop.		
	}
	
	! !

!IRInlinerMethod methodsFor: 'gen' stamp: 'md 9/23/2005 14:56'!
genMethodSender

	self reify: #sender with: num.
	num := num + 1.
	^{ 
		IRInstruction pushThisContext.
		IRInstruction send: #sender.
		IRInstruction send: #receiver.
		IRInstruction storeTemp: num - 1.		
		IRInstruction popTop.		
	}! !

!IRInlinerMethod methodsFor: 'gen' stamp: 'md 9/23/2005 14:56'!
genMethodSenderContext
	
	self reify: #senderContext with: num.
	num := num + 1.
	^{
		IRInstruction pushThisContext.
		IRInstruction send: #sender.
		IRInstruction storeTemp: num - 1.		
		IRInstruction popTop.		
	}! !

!IRInlinerMethod methodsFor: 'private' stamp: 'md 10/6/2005 16:15'!
genPreambleSequence
	| statements |
	statements :=  IRSequence new.
	num := maxTemp  +1.
	self reifyArgnMethod.
	(self  shouldReify:#receiver) 
		 ifTrue:[statements  addAll:self genMethodReceiver].	"ok"
	(self  shouldReify:#arguments) 
		 ifTrue:[statements  addAll:self genMethodArguments].	"ok"
	(self  shouldReify:#sender) 
		 ifTrue:[statements  addAll:self genMethodSender].	"ok"
	(self  shouldReify:#senderContext) 
		 ifTrue:[statements  addAll:self genMethodSenderContext].
	self additionalVars  do:
			[:each | 
			(self  shouldReify:each) 
				 ifTrue:[statements  addAll:(self  genAdditionalVars:each)]].
	^ statements! !

!IRInlinerMethod methodsFor: 'public' stamp: 'md 10/6/2005 16:19'!
insertAfter: aString
	| instr preamble postscript ensure |

	instr := self prepareForInlining: aString. 
	preamble := self genPreambleSequence.
	postscript := self genPostscript.
	self patchInlinedCode: instr.
	node removeEmptyStart.
	node startSequence addInstructions: postscript before: node startSequence last.
	
	ensure := node wrapInEnsure: instr.
	preamble ifNotEmpty: [node insertSequenceFront: preamble].
	
	node updateSequenceNumbers.! !

!IRInlinerMethod methodsFor: 'public' stamp: 'md 9/23/2005 14:17'!
insertBefore: aString
	| instr preamble |

	instr := self prepareForInlining: aString.
	preamble := self genPreambleSequence.
	self patchInlinedCode: instr.
	node insertSequenceFront: instr.
	node insertSequenceFrontNoPop: preamble.
	node updateSequenceNumbers.! !

!IRInlinerMethod methodsFor: 'private' stamp: 'md 6/21/2005 12:12'!
reifyArgnMethod
	(1 to: node numArgs) do: [:a |
			self reify: (('arg', a asString) asSymbol) with: a.
	].
! !

!IRInlinerMethod methodsFor: 'public' stamp: 'md 10/6/2005 16:14'!
replace: aString 
	| instr preamble postscript seq |
	instr := self  prepareForInlining:aString.
	preamble := self genPreambleSequence.
	postscript := self genPostscript.
	self  patchInlinedCode:instr.
	seq := IRSequence new.
	seq
		 addInstructions:preamble;
		 addInstructions:postscript;
		 addInstructions:instr;
		 add:IRInstruction returnTop.
	seq  orderNumber:node startSequence first destination orderNumber.
	node startSequence first  destination:seq.
	self  fixJumps:instr! !

!IRInlinerMethod methodsFor: 'private' stamp: 'md 6/21/2005 13:47'!
splitSequence: instr
	^node startSequence first destination splitAfterNoJump: instr last.
	! !

IRInliner subclass: #IRInlinerSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!IRInlinerSend methodsFor: 'private' stamp: 'md 10/6/2005 16:16'!
genNormalStack
	| statements maxArg |

	statements := IRSequence new.
	maxArg := 0.



	((self shouldReify: #arguments) or: [self shouldReify: #receiver]) ifTrue: [
		"push receiver"
		statements add: (IRInstruction pushTemp: (reifications at: #receiver)).
		"push all arguments later"
		maxArg :=  node selector numArgs.
	].
	(self shouldReify: #arguments) ifFalse: [
		(self shouldReify: #arg1) ifTrue: [maxArg := 1]. 
		(self shouldReify: #arg2) ifTrue: [maxArg := 2]. 
		(self shouldReify: #arg3) ifTrue: [maxArg := 3]. 
		(self shouldReify: #arg4) ifTrue: [maxArg := 4].
		(self shouldReify: #arg5) ifTrue: [maxArg := 5]. 
		(self shouldReify: #arg6) ifTrue: [maxArg := 6]. 
		(self shouldReify: #arg7) ifTrue: [maxArg := 7]. 
		(self shouldReify: #arg8) ifTrue: [maxArg := 8]. 
	].
	1 to: maxArg do: [:i |
		statements add: (IRInstruction pushTemp: (reifications at: ('arg', i asString) asSymbol)).
	].
	^statements.! !

!IRInlinerSend methodsFor: 'private' stamp: 'md 10/6/2005 16:15'!
genPreamble
	| statements n |
	statements := IRSequence new.
	num := maxTemp + 1.

	n := self maxToReifyArg.	
	((self shouldReify: #receiver) or: [(self shouldReify: #arguments)])  ifTrue: [
		n := node selector numArgs.	
		self reify: #receiver.

	].
	statements addAll: (self sendargsupto: n).
	
	(self shouldReify: #receiver) ifTrue: [statements addAll: self genReceiver].  "ok"
	(self shouldReify: #arguments) ifTrue: [statements addAll: self genSendArguments].	 "ok"
	(self shouldReify: #sender) ifTrue: [statements addAll: self genSendSender]. "ok"
	(self shouldReify: #senderContext) ifTrue: [statements addAll: self genSendSenderContext]. "ok"	

	
	self additionalVars do: [:each |  
			(self shouldReify: each) ifTrue: [statements addAll: (self genAdditionalVars: each)]
	].

	^ statements.! !

!IRInlinerSend methodsFor: 'gen' stamp: 'md 7/18/2005 09:45'!
genSendArguments
	| statements |
	num := num + 1.
	self reify: #arguments with: num - 1.
	statements := OrderedCollection new.

	"construct an array for all arguments and store it into a tmp var"
	statements addAll: {
		IRInstruction pushLiteralVariable: Array holder.
		IRInstruction pushLiteral: node selector numArgs.
		IRInstruction send: #new:.
		IRInstruction storeTemp: num - 1.				
	}.
	

	"add all arguments to the array"
		(1 to: node selector numArgs) do: [:a |
			statements addAll: { 
					IRInstruction pushDup.					
					IRInstruction pushLiteral: a.
					IRInstruction pushTemp: (reifications at: ('arg', a asString) asSymbol).
					IRInstruction send: #at:put:.
					IRInstruction popTop.
				}
			].

	statements add: IRInstruction popTop.
	^statements.! !

!IRInlinerSend methodsFor: 'gen' stamp: 'md 6/23/2005 15:17'!
genSendSender
	"ok"
	self reify: #sender with: num.
	num := num + 1.
	^ {
		IRInstruction pushReceiver.
		IRInstruction storeTemp: num -1 .		
		IRInstruction popTop.		
	}
	
	! !

!IRInlinerSend methodsFor: 'gen' stamp: 'md 6/30/2005 14:48'!
genSendSenderContext
	self reify: #senderContext with: num.
	num := num + 1.
	^ {
		IRInstruction pushThisContext.
		IRInstruction storeTemp: num -1 .		
		IRInstruction popTop.		
	}
	
	! !

!IRInlinerSend methodsFor: 'public' stamp: 'md 7/16/2005 17:31'!
insertAfter: aString
	| instr preamble postscript |
	
	instr := self prepareForInlining: aString. 
	preamble := self genPreamble, self genNormalStack.
	postscript := self genPostscript.
	self patchInlinedCode: instr.
	node 
		addInstructionsBefore: preamble;
	     addInstructionsAfter: instr;
		addInstructionsAfter: postscript.
	self
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInlinerSend methodsFor: 'public' stamp: 'md 7/16/2005 17:31'!
insertBefore: aString
	| instr preamble normalStack |

	instr := self prepareForInlining: aString.
	preamble := self genPreamble.
	normalStack := self genNormalStack.
	self patchInlinedCode: instr.
	node 
		addInstructionsBefore: preamble;
		addInstructionsBefore: instr;
		addInstructionsBefore: normalStack.
	self 
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInlinerSend methodsFor: 'private' stamp: 'md 6/29/2005 15:37'!
maxToReifyArg
	| nums |
	nums := reifications keys collect: [:each | 
				(each beginsWith: 'arg') ifTrue: [ each last digitValue] ifFalse: [0]]. 	
	nums add: 0.
	^nums max.
		! !

!IRInlinerSend methodsFor: 'public' stamp: 'md 7/16/2005 17:33'!
replace: aString
	| instr preamble |

	instr := self prepareForInlining: aString.
	preamble := self genPreamble.
	self patchInlinedCode: instr.	
	node replaceWithInstructions: preamble, instr.
	self 
		balanceStack: instr;
		fixJumps: instr.! !

!IRInlinerSend methodsFor: 'private' stamp: 'md 10/6/2005 16:16'!
sendargsupto: t
	| statements |
	statements := IRSequence new.
	1 to: t do: [:i |
				self reify: ('arg', (node selector numArgs + 1 - i) asString) asSymbol with: num.
				statements 
					add: (IRInstruction storeTemp: num);
					add: (IRInstruction popTop).
				num := num + 1.
			].
	^statements
	
	! !

!IRInliner class methodsFor: 'instance creation' stamp: 'md 6/14/2005 16:48'!
on: aNode
	^self new node: aNode.! !

!IRInliner class methodsFor: 'instance creation' stamp: 'md 10/4/2005 16:02'!
on: aNode using: variables
	| inliner |
	inliner := self new. 
	inliner node: aNode;
		    variables: variables.
	^inliner.
	! !

!IRInliner methodsFor: 'accessing' stamp: 'md 7/16/2005 22:19'!
additionalVars
	variables ifNil: [^#()] ifNotNil: [^variables keys].! !

!IRInliner methodsFor: 'name-offset table' stamp: 'md 7/1/2005 14:54'!
addTemp: symbol
	tempOffset add: symbol.! !

!IRInliner methodsFor: 'private' stamp: 'md 9/23/2005 13:37'!
balanceStack2: instr

	| jmp |
	instr withAllSuccessorsDo: [:succ |
		succ ifNotEmpty: [
	   			succ last destination isEmpty ifTrue: [
						jmp :=  succ removeLast.
						(IRStackAnalyzer analyzeNodes: succ) timesRepeat: [
							succ add: IRInstruction popTop
						].
						succ addLast: jmp.
			].
	]].! !

!IRInliner methodsFor: 'private' stamp: 'md 7/21/2005 12:17'!
balanceStackPOP: instr
	instr isEmpty ifTrue: [^self].
	instr last isGoto 
		ifFalse: [instr last addInstructionsAfter: {IRInstruction popTop}]
		ifTrue: [instr last addInstructionsBefore: {IRInstruction popTop}].
	self balanceStack: instr.! !

!IRInliner methodsFor: 'private' stamp: 'md 9/26/2005 13:09'!
balanceStack: instr 
	(IRStackAnalyzer  analyzeNodes:instr)  timesRepeat:
			[((instr  isKindOf:IRSequence)  and:[instr last isJump]) 
				 ifFalse:[instr  add:IRInstruction popTop]]! !

!IRInliner methodsFor: 'private' stamp: 'md 7/10/2005 09:19'!
fixJumps: instr
	| newSeq |
	instr ifEmpty: [^true].
	instr last isJump ifTrue: [	
		newSeq := self splitSequence: instr.
		instr last sequence withAllSuccessors do: [:succ | 
			succ ifNotEmpty: [succ last isGoto ifTrue: [
				succ last destination ifEmpty: [succ last destination: newSeq].
				succ last isIf ifTrue: [succ last otherwise ifEmpty: [
					succ last otherwise: newSeq]]
				]
		]
	].
	node method updateSequenceNumbers.
	].! !

!IRInliner methodsFor: 'gen' stamp: 'md 7/16/2005 22:24'!
genAdditionalVars: aSymbol

	self reify:  aSymbol with: num.
	num := num + 1.
	^ {
		(IRInstruction pushLiteral: (variables at: aSymbol) ).
		(IRInstruction storeTemp: num - 1).
		(IRInstruction popTop).
	}! !

!IRInliner methodsFor: 'gen' stamp: 'md 10/6/2005 16:18'!
genPostscript

	(self shouldReify: #result) ifTrue: [^self genResult] ifFalse:[^IRSequence new].! !

!IRInliner methodsFor: 'gen' stamp: 'md 7/16/2005 22:24'!
genReceiver

	self reify: #receiver with: num.
	num := num + 1.
	^{
		IRInstruction storeTemp: num - 1. 
		IRInstruction popTop.
	 }! !

!IRInliner methodsFor: 'gen' stamp: 'md 7/16/2005 22:24'!
genResult

	self reify: #result with: num.
	num := num + 1.
	^{IRInstruction storeTemp: num - 1}.! !

!IRInliner methodsFor: 'name-offset table' stamp: 'md 6/16/2005 14:17'!
getNameForTempOffset: off
	^tempOffset at: off.! !

!IRInliner methodsFor: 'name-offset table' stamp: 'md 6/16/2005 14:18'!
getOffsetForName: aSymbol
	^tempOffset indexOf: aSymbol.
	! !

!IRInliner methodsFor: 'initialize-release' stamp: 'md 7/16/2005 22:24'!
initialize

	reifications := Dictionary new.

	tempOffset := 
		#(receiver arguments result newvalue value sender senderContext receiverContext
	 	   arg1 arg2 arg3 arg4 arg5 arg6 arg7 arg8) asOrderedCollection.! !

!IRInliner methodsFor: 'public' stamp: 'md 7/16/2005 22:24'!
insertAfter: aString

	| instr |
	instr := ByteSurgeonParser parseStringForInlining: aString.
	node addInstructionsAfter: instr.
	self 
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInliner methodsFor: 'public' stamp: 'md 7/16/2005 22:24'!
insertBefore: aString

	| instr |
	instr := ByteSurgeonParser parseStringForInlining: aString.
	node addInstructionsBefore: instr.
	self 
		balanceStackPOP: instr;
		fixJumps: instr.! !

!IRInliner methodsFor: 'accessing' stamp: 'md 6/14/2005 16:49'!
node: aNode
	node := aNode.! !

!IRInliner methodsFor: 'private' stamp: 'md 6/23/2005 16:30'!
patchInlinedCode: seq
	seq withAllSuccessorsDo: [:instr |
		(instr select: [:each | each isTempAccess and:[each number >0]]) do: [:each |
			each number = 24 ifTrue: [each number: 0] ifFalse: [
		 	each number: (self reifications at: 
					(self getNameForTempOffset: each number)).]
		]
	].
		 	! !

!IRInliner methodsFor: 'private' stamp: 'md 10/25/2005 15:14'!
prepareForInliningBlock: aBlock
	| code instr neededTemps methodMaxTemp method ast blockNode blockArgs |
	
	
	neededTemps := 0.
	method := node method.
	methodMaxTemp := method tempKeys last.

	
	code := aBlock decompile printString allButFirst allButLast.
	ast := SqueakParser parseDoIt: code.
	blockNode := ast body statements first.
	blockArgs := blockNode arguments.
	blockArgs ifNotEmpty: [self error].
	
	
	"
	 -get all sends to the argument. 
	 -according to selector send, request reification
	 -replace with temp access to pre-defined temp numbers
	"
	
	instr := (RBMethodNode selector: #dd body: blockNode body)
					 ir removeReturn removeEmptyStart startSequence.
	instr removeLast.
	"fixme: name analysis in original method..."

	"add the additonal vars"
	self additionalVars do: [:v | self reify: v].

	"add only new temps if this hook needs more than we have inserted by any hook before"
	(maxTemp + neededTemps > methodMaxTemp) ifTrue: [ 
		method addTemps: (methodMaxTemp to: (maxTemp + neededTemps - methodMaxTemp)) asArray.
	].

	^instr.! !

!IRInliner methodsFor: 'private' stamp: 'md 10/25/2005 12:00'!
prepareForInliningCode: aString
	| method methodMaxTemp  instr neededTemps|


	neededTemps := 0.
	method := node method.
	methodMaxTemp := method tempKeys size.

	instr := ByteSurgeonParser parseStringForInlining: aString inliner: self.
	instr instructionsDo: [:each | | srcNode | each isTempAccess ifTrue: [srcNode := each sourceNode.
		(srcNode isMeta and: [srcNode reify = #arguments] and: [node isSend]) ifTrue: [neededTemps := neededTemps + node selector numArgs + 1. self reify: srcNode reify] ifFalse: [
		(srcNode isMeta and: [srcNode reify beginsWith: 'arg']) ifTrue: [self reify: srcNode reify] ifFalse: [
		srcNode isMeta ifTrue: [neededTemps := neededTemps + 1. self reify: srcNode reify]]].
	]].

	"add the additonal vars"
	self additionalVars do: [:v | self reify: v].

	"add only new temps if this hook needs more than we have inserted by any hook before"
	(maxTemp + neededTemps > methodMaxTemp) ifTrue: [ 
		method addTemps: (methodMaxTemp to: (maxTemp + neededTemps - methodMaxTemp)) asArray.
	].

	^instr.! !

!IRInliner methodsFor: 'private' stamp: 'md 9/26/2005 13:09'!
prepareForInliningStatements: aCollectionOfIRNodes 
	^ (IRSequence new)
		 addAll:aCollectionOfIRNodes;
		yourself! !

!IRInliner methodsFor: 'private' stamp: 'md 9/30/2005 14:49'!
prepareForInlining: aString

	maxTemp := node method originalMaxTemp.
	aString isString ifTrue: [^self prepareForInliningCode: aString].
	aString isBlock  ifTrue: [^self prepareForInliningBlock: aString].
	 ^self prepareForInliningStatements: aString.! !

!IRInliner methodsFor: 'accessing' stamp: 'md 6/14/2005 16:51'!
reifications
	^reifications! !

!IRInliner methodsFor: 'reifications' stamp: 'md 7/16/2005 22:25'!
reify: aSymbol

	self reify: aSymbol with: true.! !

!IRInliner methodsFor: 'reifications' stamp: 'md 7/16/2005 22:24'!
reify: aSymbol with: aNumber

	self reifications at: aSymbol put: aNumber.! !

!IRInliner methodsFor: 'public' stamp: 'md 7/16/2005 17:32'!
replace: aStringOrBlock

	| instr |
	instr := ByteSurgeonParser parseStringForInlining: aStringOrBlock.
	node replaceWithInstructions: instr.
	self 
		balanceStack: instr;
		fixJumps: instr.! !

!IRInliner methodsFor: 'reifications' stamp: 'md 7/16/2005 22:26'!
shouldReify: aSymbol

	self reifications at: aSymbol ifAbsent: [^false].
	^true.! !

!IRInliner methodsFor: 'private' stamp: 'md 6/21/2005 13:47'!
splitSequence: instr
	^node sequence splitAfterNoJump: instr last.! !

!IRInliner methodsFor: 'private' stamp: 'md 7/13/2005 17:11'!
stackCheck: instr	
	| stackheight |
	stackheight := IRStackAnalyzer analyzeNodes: instr.
	self assert: stackheight = 0.! !

!IRInliner methodsFor: 'accessing' stamp: 'md 7/21/2005 19:32'!
variables: aDict
	aDict ifNotNil: [
		variables := aDict isDictionary ifTrue: [aDict] ifFalse: [Dictionary newFrom: aDict].
		variables keys do: [:each | self addTemp: each]
	]! !

Object subclass: #IRNumberer
	instanceVariableNames: 'num seen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!IRNumberer class methodsFor: 'as yet unclassified' stamp: 'md 6/21/2005 13:44'!
on: ir
	self new reNumber: ir.! !

!IRNumberer methodsFor: 'private' stamp: 'md 5/12/2005 21:17'!
reNumber: irMethod
	num := 0.
	seen := Set new.
	self visitSuccessors: irMethod startSequence.
	
	! !

!IRNumberer methodsFor: 'private' stamp: 'md 5/12/2005 21:20'!
visitSuccessors: irSequence
	(seen includes: irSequence) ifFalse: [
		seen add: irSequence.
		irSequence orderNumber: num.
		num := num + 1.
		irSequence successorSequences reversed do: [:each |
				self visitSuccessors: each.
		].
	].! !

Object subclass: #Metaobject
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!Metaobject methodsFor: 'as yet unclassified' stamp: 'md 7/19/2005 19:45'!
instVarRead: name in: object
	| val |
	val := object instVarNamed: name.
	Transcript show: 'var read: ', val printString; cr.
	^val.! !

!Metaobject methodsFor: 'as yet unclassified' stamp: 'md 7/19/2005 19:45'!
instVarStore: name in: object value: newVal 
	Transcript show: 'var store: ', newVal printString; cr.
	^object instVarNamed:  name put: newVal.
	! !

Object subclass: #MOExample
	instanceVariableNames: 'i'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!MOExample methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 10:04'!
read
	^ i + i! !

!MOExample methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 10:11'!
store: value
	i := value.   ! !

Object subclass: #MOP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!MOP class methodsFor: 'as yet unclassified' stamp: 'md 10/4/2005 16:10'!
install: mop on: aClass
	| dict |
	dict := Dictionary newFrom: {#mo -> mop}.
	aClass instrumentInstVarAccess: [:instr |
		dict at: #name put: instr varname.	
		instr isRead 
			ifTrue: [instr replace: '<meta: #mo> instVarRead: <meta: #name> in: self' using: dict] 
			ifFalse: [instr replace: '<meta: #mo> instVarStore: <meta: #name> in: self value: <meta: #newvalue>' using: dict]
	]! !

!MOP class methodsFor: 'as yet unclassified' stamp: 'md 7/20/2005 10:21'!
uninstall: aClass
	aClass uninstallByteSurgeon.! !

!Object methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 15:00'!
instVarNameForOffset: offset
	^self class instVarNameForOffset: offset.! !

!RBProgramNodeVisitor methodsFor: '*ByteSurgeon' stamp: 'md 4/28/2005 15:47'!
acceptByteSurgeonNode: aNode
	! !

!RBProgramNode methodsFor: '*byteSurgeon' stamp: 'md 6/21/2005 13:50'!
isMeta
	^false.! !

TestCase subclass: #BSMethodWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-MW'!

!BSMethodWrapperTest methodsFor: 'testing' stamp: 'md 7/10/2005 09:36'!
testMethodWrapper
	|w|
	BCounter reset. BSExamples compileAll.

	w := TestMethodWrapperSimple on: #tempAccess inClass: BSExamples.
	w install.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 6).
 
	BCounter reset. w uninstall.
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 0).
! !

!BSMethodWrapperTest methodsFor: 'testing' stamp: 'md 7/10/2005 09:45'!
testMethodWrapperWithState
	
	|w|

	BCounter reset.
	BSExamples compileAll.

	w := TestMethodWrapperCounter on: #tempAccess inClass: BSExamples.
	w install.

	self assert: (w counter = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (w counter = 3).

	w uninstall. w reset.
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (w counter = 0).
! !

TestCase subclass: #ByteSurgeonTest
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

ByteSurgeonTest class
	instanceVariableNames: 'rem'!

!ByteSurgeonTest commentStamp: '<historical>' prior: 0!
These are some tests for Bytesurgeon.!

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 6/24/2005 16:05'!
recompile: sel

	BSExamples recompile: sel.! !

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:24'!
rem
	^rem.! !

!ByteSurgeonTest class methodsFor: 'as yet unclassified' stamp: 'md 2/10/2005 18:24'!
rem: anObject
	rem := anObject.! !

!ByteSurgeonTest methodsFor: 'tools' stamp: 'md 6/24/2005 16:14'!
recompile: sel

	BSExamples recompile: sel.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 10/4/2005 16:08'!
testAccessAdditionalVars

	| vars |
	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'self assert: <meta: #hello> = 20' using: vars.
	].
	BSExamples new instAccess.
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 10/4/2005 16:09'!
testAccessAdditionalVarsNoDict

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'self assert: <meta: #hello> = 20' using:  {#hello -> 20}.
	].
	BSExamples new instAccess.
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:12'!
testAddAfterInstVarRead
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 7/22/2005 14:34'!
testAddAfterInstVarStore
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:14'!
testAddBeforeInstVarRead
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertBefore: 'BCounter inc'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 7/1/2005 11:30'!
testAddBeforeInstVarStore
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replaceAndStore: '2'.
	].

	self assert: (BSExamples new instAccess = 2).

	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:15'!
testAddBeforInstVarStoreSpecialVarNewValue

	self recompile: #instAccess.

	self assert: (BSExamples new instAccess = 1).


	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertBefore: 'self assert: (<meta: #newvalue> = 1).'
	].

	self assert: (BSExamples new instAccess=1).


	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:11'!
testAddCodeAfterSend

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | send insertAfter: 'BCounter inc'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 10/4/2005 16:09'!
testAddCodeAfterSendAdditonalVar
	| vars |
	self recompile: #return2Squared.	
	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'self assert: <meta: #hello> = 20' using: vars
	].
	BSExamples new return2Squared.
	self recompile: #return2Squared.

	! !

!ByteSurgeonTest methodsFor: 'testing - blocks' stamp: 'md 10/11/2005 22:41'!
testAddCodeAfterSendBlock

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | send insertAfter: [BCounter inc]].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:11'!
testAddCodeAfterSendComplex

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
				send insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:09'!
testAddCodeBeforeSend
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | send insertBefore: 'BCounter inc'].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:07'!
testAddCodeBeforeSendComplex
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send |
			send insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/24/2005 16:15'!
testAddCodeReplaceSendComplex
	"same, just use #addbefore:"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:07'!
testAfterComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertAfter: '(1< 2) ifTrue: [(1<2) ifTrue: [Transcript show: ''constant'']].'.
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 8/10/2005 13:37'!
testAfterMethod

	BCounter reset.
	self recompile: #return2Squared.

    (BSExamples>>#return2Squared) insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 10/4/2005 16:09'!
testAfterMethodAdditionalVar

	| vars |
	self recompile: #return2Squared.
	vars := Dictionary newFrom: {#hello -> 20}.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'self assert: <: #hello> = 20' using: vars
	].
	BSExamples new return2Squared.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodArg7and3

	self recompile: #returnParamWith:with:with:with:with:with:with:.

	(BSExamples>>#returnParamWith:with:with:with:with:with:with:) insertBefore: 
				'self assert: (<meta: #arg7> = 7). self assert: (<meta: #arg3> = 3)'.

	BSExamples new receiverManyArgs.
	
	self recompile: #returnParamWith:with:with:with:with:with:with:.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodArgs

	self recompile: #returnParamWith:with:with:with:with:with:with:.

	(BSExamples>>#returnParamWith:with:with:with:with:with:with:) insertBefore: 
				'self assert: (<meta: #arguments> size = 7) '.

	BSExamples new receiverManyArgs.
	
	self recompile: #returnParamWith:with:with:with:with:with:with:.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 8/10/2005 11:55'!
testAfterMethodSimple

	BCounter reset.
	self recompile: #return2Squared.

    (BSExamples>>#return2Squared) insertAfter: 'BCounter inc'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 8/10/2005 17:44'!
testAfterMethodVarContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: 'BCounter inc. self assert: thisContext class == BlockContext '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:21'!
testAfterMethodVarResult

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: 'BCounter inc. self assert: <meta: #result> = 4 '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg1

	self recompile: #receiverArgs.

	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
			send replace: 'self assert: <meta: #arg1> = 1'
	].

	BSExamples new receiverArgs.
	self recompile: #receiverArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg2

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
		(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: <meta: #arg2> = 2'
		]
	].

	BSExamples new receiverArgs2.
	
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg7

	self recompile: #receiverManyArgs.

	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
			send replace: 'self assert: <meta: #arg7> = 7'
	].

	BSExamples new receiverManyArgs.
	
	self recompile: #receiverManyArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:20'!
testAfterSpecialVarArg7and3

	self recompile: #receiverManyArgs.

	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
		send replace: 'self assert: <meta: #arg7> = 7. self assert: <meta: #arg3> = 3'
	].

	BSExamples new receiverManyArgs.	
	self recompile: #receiverManyArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:21'!
testAfterSpecialVarArgReceiver

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: <meta: #arg2> = 2. self assert: <meta: #receiver> class = BSExamples'.
			]
	].

	BSExamples new receiverArgs2.
	
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:21'!
testAfterSpecialVarArgs

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
		(send selector = #returnParam:and:) ifTrue: [
			send insertAfter: 'self assert: <meta: #arguments> = #(1 2)'.
		]
	].

	BSExamples new receiverArgs2.
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - blocks' stamp: 'md 10/25/2005 15:11'!
testAfterSpecialVarArgsBlock

	self recompile: #receiverArgs2.

	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
		(send selector = #returnParam:and:) ifTrue: [
			send insertAfter: [:meta | self assert: meta arguments = #(1 2)].
		]
	].

	BSExamples new receiverArgs2.
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:22'!
testAfterSpecialVarResult

	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendResult: <meta: #result>'.
	].

	self assert: (BSExamples new returnParam: 2) = 2.
	
	self recompile: #returnParam:.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testAfterSpecialVars
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendBeforeOrAfter:', send selector printString, ' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnParam: 2) = 2.
	self assert: (BCounter count = 2).

	BCounter reset.
	self recompile: #returnParam:.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testAfterSpecialVars2
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnWithComplexSend.

	(BSExamples>>#returnWithComplexSend) instrumentSend: [:send | 
			send insertAfter: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnWithComplexSend) = 28.
	self assert: (BCounter count = 7).

	BCounter reset.
	self recompile: #returnWithComplexSend.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:13'!
testBeforeMethod

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:15'!
testBeforeMethodComplex

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:22'!
testBeforeMethodTrueFalse

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'self assert: true = false not'.

	3 timesRepeat: [BSExamples new return2Squared].

	
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:22'!
testBeforeMethodVarContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: thisContext class = MethodContext  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:23'!
testBeforeMethodVarReceiver

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: <meta: #receiver> class == BSExamples '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:17'!
testBeforeMethodVarSelector

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc.  self assert: thisContext selector = #return2Squared  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:23'!
testBeforeMethodVarSelf

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: self class == BSExamples '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/27/2005 16:17'!
testBeforeMethodVarSender

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: <meta: #sender> class == ByteSurgeonTest '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'dr 9/10/2005 20:48'!
testBeforeMethodVarSenderContext

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: 'BCounter inc. self assert: (<meta: #senderContext> isKindOf: ContextPart)  '.

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testBeforeSpecialVars
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnParam:.

	(BSExamples>>#returnParam:) instrumentSend: [:send | 
			send insertBefore: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnParam: 2) = 2.
	self assert: (BCounter count = 2).

	BCounter reset.
	self recompile: #returnParam:.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testBeforeSpecialVars2
	"Test sending a msg to a metaobject after a base-level send"

	BCounter reset.
	self recompile: #returnWithComplexSend.

	(BSExamples>>#returnWithComplexSend) instrumentSend: [:send | 
			send insertBefore: 'BSExamples sendBeforeOrAfter:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'.
	].

	self assert: (BCounter count = 0).
	self assert: (BSExamples new returnWithComplexSend) = 28.
	self assert: (BCounter count = 7).

	BCounter reset.
	self recompile: #returnWithComplexSend.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 7/9/2005 21:29'!
testBug1
	"test written for bugreport:
	Von: 	  hawkie@bluewin.ch
	Betreff: 	bytesurgeon fehler?
	Datum: 	4. Juli 2005 20:14:31 GMT+02:00
	An: 	  denker@iam.unibe.ch"


	self recompile: #bug1.

	(BSExamples>>#bug1) instrumentSend: [:send | send insertBefore: 'BCounter inc' ].
	
	BSExamples new bug1.
	self recompile: #bug1.

	! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'ch 10/3/2005 17:30'!
testBug10
	
	self recompile: #bug10.

	(BSExamples>>#bug10) instrumentSend: [:instr | 
				instr insertAfter: 'self assert: true'
	].
	self shouldnt: [BSExamples new bug10] raise: Error.

	self recompile: #bug10.! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'abc 10/26/2005 15:17'!
testBug11
	
	self recompile: #t.
	BCounter reset.

	(BSExamples>>#t) instrument: [:instr | 
				instr isReturn ifTrue: [instr insertBefore: 'BCounter inc'].
	].
	(BSExamples new) t.
	self assert: BCounter count = 1.

	self recompile: #t.! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 7/14/2005 13:48'!
testBug2
	"test written for bugreport:
	Von: 	  hawkie@bluewin.ch
	Betreff: 	stack out of sync
	Datum: 	13. Juli 2005 11:20:24 GMT+02:00
	An: 	  bytesurgeon@iam.unibe.ch"

	| class |

	class := Smalltalk at: #MCDefinition ifAbsent: nil.
	class ifNil: [^self].

	(class class>>#instanceLike:) recompile.

	self shouldnt: [
		(class class>>#instanceLike:) instrument:  [:instr | 
			(instr isSend and: [instr selector = #new])  ifTrue: [ 
				instr insertBefore: 'Transcript show: <meta: #arguments> printString; cr.' ]].
		] raise: Error.
	(class class>>#instanceLike:) recompile

	! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 7/14/2005 13:53'!
testBug3
	"test written for bugreport:
	Von: 	  hawkie@bluewin.ch
	Betreff: 	bytesurgeon fehler?
	Datum: 	4. Juli 2005 20:14:31 GMT+02:00
	An: 	  denker@iam.unibe.ch"


	self recompile: #bug3.

	(BSExamples>>#bug3) instrumentSend: [:instr | 
				instr insertBefore: 'Transcript show: <meta: #arguments> printString; cr.'
	].

	self shouldnt: [BSExamples new bug3] raise: Error.

	self recompile: #bug3.! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 7/15/2005 23:17'!
testBug4
	"test written for bugreport:
	Von: 	  hawkie@bluewin.ch
	Betreff: 	instvars
	Datum: 	15. Juli 2005 18:35:12 GMT+02:00
	An: 	  bytesurgeon@iam.unibe.ch"


	BSExamplesSub compileAll.

	(BSExamplesSub>>#bug4) instrument: [:instr | instr isInstVarRead ifTrue: [instr insertAfter:
'Transcript show: ', instr varname printString,' printString; cr.']].

	self shouldnt: [BSExamplesSub new bug4] raise: Error.

	BSExamplesSub compileAll.
! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 7/22/2005 11:59'!
testBug5
	"Method does not answer the right object on an insertAfter: instrumentation."

	BCounter reset.
	self recompile: #returnParam:and:.

	(BSExamples>>#returnParam:and:) insertAfter: 'BCounter inc. self assert: <meta: #result> = 7.'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new returnParam: 2 and: 5) = 7].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #returnParam:and:.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 9/7/2005 16:57'!
testBug6
	"Stack out of sync error when using jumps in message receive controls"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: '1 < 2 ifTrue: [BCounter inc] ifFalse: [self halt]. ', 
                                                          'self assert: <meta: #receiver> class = BSExamples.'.
	(BSExamples>>#return2Squared) insertAfter: '1 < 2 ifTrue: [BCounter inc] ifFalse: []'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: BSExamples new return2Squared = 4].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 9/7/2005 16:57'!
testBug6a
	"Stack out of sync error when using jumps in message receive controls"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: '1 < 2 ifTrue: [BCounter inc] ifFalse: [self halt]. ', 
                                                          'self assert: <meta: #receiver> class = BSExamples.'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: BSExamples new return2Squared = 4].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 9/7/2005 16:45'!
testBug6b
	"Stack out of sync error when using jumps in message receive controls"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: '1 < 2 ifTrue: [BCounter inc] ifFalse: []'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: BSExamples new return2Squared = 4].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 8/9/2005 17:39'!
testBug6nd
	"Stack out of sync error when using jumps in message receive controls"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertBefore: '1 < 2 ifTrue: [BCounter inc] ifFalse: [self halt]. ', 
                                                          'self assert: <meta: #receiver> class = BSExamples.' after: '1 < 2 ifTrue: [BCounter inc] ifFalse: []'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: BSExamples new return2Squared = 4].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 9/29/2005 11:26'!
testBug7
	"MessageNotUnderstood in IRStackAnalyzer / stack out of sync"

	BCounter reset.
	Date recompile: #asGregorian.

	(Date>>#asGregorian) insertBefore: '1 < 2 ifTrue: [BCounter inc; inc.] ifFalse: [self error]'.
	(Date>>#asGregorian) insertAfter: '1 < 2 ifTrue: [BCounter inc; inc.] ifFalse: [self error]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [Date today asGregorian].
	self assert: (BCounter count = 12).

	BCounter reset.
	Date recompile: #asGregorian.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'md 9/29/2005 11:18'!
testBug7nd
	"MessageNotUnderstood in IRStackAnalyzer / stack out of sync"

	BCounter reset.
	Date recompile: #asGregorian.

	(Date>>#asGregorian) insertBefore: '1 < 2 ifTrue: [BCounter inc; inc.] ifFalse: [self error]' after: '1 < 2 ifTrue: [BCounter inc; inc.] ifFalse: [self error]'.

	self assert: (BCounter count = 0).
	3 timesRepeat: [Date today asGregorian].
	self assert: (BCounter count = 12).

	BCounter reset.
	Date recompile: #asGregorian.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'dr 9/11/2005 15:27'!
testBug8
	"sender & senderContext wrong for after controls"

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) insertAfter: 'BCounter inc. self assert: <meta: #sender> class == ByteSurgeonTest.
												self assert: (<meta: #senderContext> isKindOf: ContextPart)'.

	self assert: (BCounter count = 0).
	1 timesRepeat: [self assert: BSExamples new return2Squared = 4].
	self assert: (BCounter count = 1).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).

! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'ch 10/3/2005 16:59'!
testBug9
	
	self recompile: #bug9.

	(BSExamples>>#bug9) instrumentSend: [:instr | 
				instr insertAfter: 'self assert: true'
	].
	self shouldnt: [BSExamples new bug9] raise: Error.

	self recompile: #bug9.! !

!ByteSurgeonTest methodsFor: 'tests - bugs' stamp: 'ch 10/5/2005 16:44'!
testBug9a	
	self recompile: #bug9a.

	(BSExamples>>#bug9a) instrumentAll: { [:instr | instr isSend ifTrue: [ instr insertAfter: 'self assert: true' ] ] }.
	"(BSExamples>>#bug9a) instrumentSend: [:send | send insertAfter: 'self assert: true' ]."
	self shouldnt: [BSExamples new bug9a] raise: Error.

	self recompile: #bug9a.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 7/11/2005 23:21'!
testCountInstVarAccess

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarAccess: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #instAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:15'!
testCountInstVarRead

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: 'BCounter inc'
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:11'!
testCountInstVarWrite

	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - literalVariable' stamp: 'md 10/4/2005 16:54'!
testCountLitVarRead

	BCounter reset.
	self recompile: #literalVarRead.
 
	(BSExamples>>#literalVarRead) instrument: [:instr | instr isLiteralVariableRead ifTrue: [
		instr insertAfter: 'BCounter inc'.
		]
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new literalVarRead = Object)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:13'!
testCountSends

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
			send insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempValue

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
			temp insertAfter: 'self assert: (<meta: #value> = nil)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:14'!
testCountTempVarAccess

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempAccess: [:temp | 
		temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:13'!
testCountTempVarComplexAfter

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:10'!
testCountTempVarComplexBefore

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:10'!
testCountTempVarComplexReplace

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new tempAccess].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarName

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempAccess: [:temp | 
		temp insertAfter: 'self assert: ', temp varname printString, ' = ''tt'''.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarNewValue

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (<meta: #newvalue> = 1)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarOffset

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: ', temp offset printString, ' = 1'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:16'!
testCountTempVarRead

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempRead: [:temp | 
		temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:18'!
testCountTempVarSelector

	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (', temp selector printString, ' = #tempAccess)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/27/2005 16:23'!
testCountTempVarSelf
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
		temp insertAfter: 'self assert: (self class = BSExamples)'.
	].

	self assert: (BSExamples new tempAccess = 1).
	self recompile: #tempAccess.

	! !

!ByteSurgeonTest methodsFor: 'testing - temps' stamp: 'md 6/24/2005 16:12'!
testCountTempVarWrite

	BCounter reset.
	self recompile: #tempAccess.

	(BSExamples>>#tempAccess) instrumentTempStore: [:temp | 
			temp insertAfter: 'BCounter inc'.
	].

	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new tempAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #tempAccess.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'examples - paper' stamp: 'md 6/27/2005 16:35'!
testEx43

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
		send selector = #squared ifTrue: [send selector: #negated ] ].

	self assert: (BSExamples new return2Squared = -2).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'examples - paper' stamp: 'md 6/27/2005 16:35'!
testEx43b

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentSend: [:send | 
		send selector = #squared ifTrue: [send replace: {IRInstruction send: #negated}]. 
 	].

	self assert: (BSExamples new return2Squared = -2).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:14'!
testExampleComplexExpression
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertBefore: '(1< 2) ifTrue: [Transcript show: ''constant''].'.
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:16'!
testExampleComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
			const insertBefore: '(1< 2) ifTrue: [(1<2) ifTrue: [Transcript show: ''constant'']].'
	].
	self assert: 	BSExamples new return2Squared = 4.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:09'!
testExampleTranscript
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
		const insertBefore: 'Transcript show: ''constant'''.
	].
	self assert: 	BSExamples new return2Squared = 4.

	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - fromCode' stamp: 'md 10/25/2005 11:05'!
testFromCode

	BCounter reset.
	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentFromCode: [:instr | instr isSend ifTrue: [
			 instr insertAfter: 'BCounter inc'].
		].
	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new return2Squared].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #return2Squared.
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/30/2005 17:10'!
testInstrumentAll
	| aBlockCollection |

	BCounter reset.
	self recompile: #instAccess.

	aBlockCollection := {
		[:instr | instr isInstVarRead ifTrue: [instr insertAfter: 'BCounter inc']].
		[:instr | instr isInstVarStore ifTrue: [instr insertAfter: 'BCounter inc']]
	}.

	(BSExamples>>#instAccess) instrumentAll: aBlockCollection.
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 6).

	BCounter reset.
	self recompile: #instAccess.
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 0).
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:12'!
testInstrumentClass

	self assert: BSExamples new return2Squared = 4.

	BSExamples instrumentConstant: [:const | 
		const constant: 3.
	].

	self assert: BSExamples new return2Squared = 9.
	BSExamples compileAll.
	self assert: BSExamples new return2Squared = 4.! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:13'!
testInstrumentMethod

	self recompile: #return2Squared.
	self assert: BSExamples new return2Squared = 4.

	(BSExamples>>#return2Squared) instrumentConstant: [:const | 
		const constant: 3.
	].

	self assert: BSExamples new return2Squared = 9.
	self recompile: #return2Squared.
	self assert: BSExamples new return2Squared = 4.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:09'!
testInstVarAfterComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertAfter: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:13'!
testInstVarBeforeComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr insertBefore: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	
	self assert: (BCounter count = 0).
	3 timesRepeat: [self assert: (BSExamples new instAccess = 1)].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:10'!
testInstVarReplaceComplex
	
	BCounter reset.
	self recompile: #instAccess.

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: '(1<2) ifTrue: [(1<2) ifTrue: [BCounter inc]]'.
	].
	
	self assert: (BCounter count = 0).
	3 timesRepeat: [BSExamples new instAccess].
	self assert: (BCounter count = 3).

	BCounter reset.
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:14'!
testReplace

	self recompile: #return2Squared.

	(BSExamples>>#return2Squared) instrumentConstant: [:const | 
		const replace: '5'.
	].

	self assert: (BSExamples new return2Squared = 25).
	self recompile: #return2Squared.
	! !

!ByteSurgeonTest methodsFor: 'testing - misc' stamp: 'md 6/24/2005 16:15'!
testReplaceComplexExpression2
	
	self recompile: #return2Squared.

	( BSExamples>>#return2Squared ) instrumentConstant: [:const | 
		const replace: '(1< 2) ifTrue: [(1<2) ifTrue: [3]].'
	].
	self assert: 	BSExamples new return2Squared = 9.
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/24/2005 16:08'!
testReplaceInstVarRead

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | instr replace: '5'].

	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarName

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readName: ', instr varname printString.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarOffset

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples read: ', instr offset printString.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarSelector

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readSelector: ', instr selector printString .
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarSelf

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readObject: self'.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:13'!
testReplaceInstVarReadSpecialVarValue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarRead: [:instr | 
		instr replace: 'BSExamples readValue: <meta: #value>'.
	].
	self assert: (BSExamples new instAccess = 5).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 7/19/2005 16:00'!
testReplaceInstVarStore

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr |  instr replace: '5'].

	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:20'!
testReplaceInstVarStoreSpecialVarNewvalue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replace: 'self assert: <meta: #newvalue> = 1'.
	].
	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - fields' stamp: 'md 6/27/2005 16:20'!
testReplaceInstVarStoreSpecialVarValue

	self recompile: #instAccess.
	self assert: (BSExamples new instAccess = 1).

	(BSExamples>>#instAccess) instrumentInstVarStore: [:instr | 
		instr replace: 'self assert: <meta: #value> = nil'.
	].
	self assert: (BSExamples new instAccess = nil).
	self recompile: #instAccess.
	! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:14'!
testReplaceMethod

	self recompile: #return2Squared.
	(BSExamples>>#return2Squared) replace: '^thisContext class'.
	self assert: (BSExamples new return2Squared = MethodContext).
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - method' stamp: 'md 6/24/2005 16:12'!
testReplaceMethodComplex

	self recompile: #return2Squared.
	(BSExamples>>#return2Squared) replace: '(1<2) ifTrue: [(1<2) ifTrue: [^thisContext class]]'.
	self assert: (BSExamples new return2Squared = MethodContext).
	self recompile: #return2Squared.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVars

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendWithArgs: <meta: #arguments>'
		]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVars2

	self recompile: #receiverArgs.
	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
				send replace: 'BSExamples sendTo: <meta: #receiver> selector: ',send selector printString.
	]. 
	self assert: (BSExamples new receiverArgs = 1).
	self recompile: #receiverArgs.
	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsContext

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendContext: thisContext'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsSelf

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendSender: self'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSomeSpecialVarsSender

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'BSExamples sendSender: <meta: #sender>'
			]
	]. 
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/30/2005 14:52'!
testReplaceSomeSpecialVarsSenderContext

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send selector = #returnParam:and:) ifTrue: [
				send replace: 'self assert: (<meta: #senderContext> class = MethodContext) '
				
			]
	]. 
	BSExamples new receiverArgs2.
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVars

	self recompile: #receiverArgs.
	(BSExamples>>#receiverArgs) instrumentSend: [:send | 
				send replace: 'BSExamples send:', send selector printString, ' args: <meta: #arguments> to: <meta: #receiver>'
	]. 
	self assert: (BSExamples new receiverArgs = 1).
	self recompile: #receiverArgs.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVars2

	self recompile: #receiverArgs2.
	(BSExamples>>#receiverArgs2) instrumentSend: [:send | 
			(send evaluate: [:i | i selector = #returnParam:and:]) ifTrue: [
				send replace: 'BSExamples send:', send selector printString,' args: <meta: #arguments> to: <meta: #receiver>'
			]
	].
	self assert: (BSExamples new receiverArgs2 = 3).
	self recompile: #receiverArgs2.

	! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVarsComplexArgs

	self recompile: #receiverComplexArgs.
	(BSExamples>>#receiverComplexArgs) instrumentSend: [:send | 
			(send selector = #returnParamWith:and:and:) ifTrue: [
				send replace: 'BSExamples send:', send selector printString, ' complexArgs: <meta: #arguments> to: <meta: #receiver>'
		]
	].
	self assert: (BSExamples new receiverComplexArgs = 17).
	self recompile: #receiverComplexArgs.! !

!ByteSurgeonTest methodsFor: 'testing - sends' stamp: 'md 6/27/2005 16:15'!
testReplaceSpecialVarsManyArgs

	self recompile: #receiverManyArgs.
	(BSExamples>>#receiverManyArgs) instrumentSend: [:send | 
			 send selector = #returnParamWith:with:with:with:with:with:with: ifTrue: [
				send replace: 'BSExamples send: ', send selector printString, ' manyArgs: <meta: #arguments> to: <meta: #receiver>'
			]
	].
	self assert: (BSExamples new receiverManyArgs = 28).
	self recompile: #receiverManyArgs.

	! !

TestCase subclass: #IRStackAnalyzerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Tests'!

!IRStackAnalyzerTest methodsFor: 'as yet unclassified' stamp: 'md 2/27/2005 17:41'!
testSimpleMethod
	| irMethod stackheight |

	irMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		ir.

	stackheight := IRStackAnalyzer  analyzeIR: irMethod.
	self assert: stackheight = 1.! !

!IRStackAnalyzerTest methodsFor: 'as yet unclassified' stamp: 'md 2/27/2005 17:41'!
testSimpleNodes
	| col stackheight |

	col := {IRInstruction pushTemp: 1}.

	stackheight := IRStackAnalyzer analyzeNodes: col.
	self assert: stackheight = 1.! !

SqueakParser subclass: #ByteSurgeonParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonParser commentStamp: '<historical>' prior: 0!
Modified Parser for Bytesurgeon: This adds support for <ARGS: aNumber> access to unamed arguments!

!ByteSurgeonParser class methodsFor: 'generated-comments' stamp: 'md 10/4/2005 15:57'!
parserDefinitionComment

	"%id <name> <number> <negativeNumber> <binarySymbol> <period>;
%start Sequence MethodPattern;

Method:
	MethodPattern Sequence						{#method:}
|	MethodPattern Primitive Sequence			{#methodPrim:}
|	MethodPattern Temporaries Primitive Statements {#methodTempsPrim:};

MethodPattern:
	<name>										{#unaryMessage:}
|	<binarySymbol> Variable						{#messagePart:}
|	KeywordMethodPattern						{#first:};

KeywordMethodPattern:
	<keyword> Variable							{#messagePart:}
|	KeywordMethodPattern <keyword> Variable	{#addMessagePart:};

Primitive:
	""<"" PrimitiveMessage "">""						{#primitiveMessage:};

Sequence:
	Statements									{#sequence:}
|	Temporaries Statements						{#sequenceWithTemps:};

Temporaries:
	""||""											{#array}
|	""|"" TemporaryVariables ""|""					{#second:};

TemporaryVariables:
												{#array}
|	TemporaryVariables Variable				{#add:};

Statements:
												{#array}
|	StatementList <period>?						{#first:}
|	StatementList <period> ""^"" Expression <period>?	{#returnAdd:}
|	""^"" Expression <period>?						{#return:};

StatementList:
	Expression									{#firstIn:}
|	StatementList <period> Expression				{#add3:};

Block:
	""["" BlockArgs ""|"" Sequence ""]""					{#blockWithArgs:}
|	""["" Sequence ""]""								{#blockNoArgs:}
|	""["" BlockArgs ""]""								{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]"" {#blockWithTemps:};

BlockArgs:
	"":"" Variable									{#secondIn:}
|	BlockArgs "":"" Variable						{#add3:};

Expression:
	Assignment									{#first:}
|	Cascade										{#first:}
|	Primary									{#first:};

Primary:
	""("" Expression "")""								{#second:}
|	Array										{#first:}
|	Block										{#first:}
|	Literal										{#first:}
|	Variable									{#first:};

Assignment:
	Variable <assignment> Expression				{#assignment:};

Cascade:
	MessageSend								{#first:}
|	Cascade "";"" Message							{#cascade:};

MessageSend:
	KeywordMessageSend						{#first:}
|	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:};

Message:
	UnaryMessage								{#first:}
|	BinaryMessage								{#first:}
|	KeywordMessage							{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage			{#messageSend:}
|	UnaryMessageSend KeywordMessage			{#messageSend:}
|	Primary KeywordMessage					{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument				{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument {#addMessagePart:};

KeywordArgument:
	BinaryMessageSend							{#first:}
|	UnaryMessageSend							{#first:}
|	Primary									{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage			{#messageSend:}
|	UnaryMessageSend BinaryMessage			{#messageSend:}
|	Primary BinaryMessage						{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument				{#messagePart:};

BinaryArgument:
	UnaryMessageSend							{#first:}
|	Primary									{#first:};

UnaryMessageSend :
	UnaryMessageSend UnaryMessage			{#messageSend:}
|	Primary UnaryMessage						{#messageSend:};

UnaryMessage :
	<name>										{#unaryMessage:};

Array:
	""{"" Statements ""}""								{#array:};

Variable: 
	<name>										{#variable:};

Literal:
	""true""										{#litTrue:}
|	""false""										{#litFalse:}
|	""nil""										{#litNil:}
|	<number>									{#litNumber:}
|	<negativeNumber>							{#litNumber:} 
|	<character>									{#litChar:}
|	<string>										{#litString:}
|	""#"" <string>									{#litStringSymbol:}
|	""#"" <name>									{#litSymbol:}
|	""#"" <binarySymbol>							{#litSymbol:}
|	""#"" <keyword>								{#litSymbol:}
|	""#"" <multikeyword>							{#litSymbol:}
|	""#"" <alternateKeyword>						{#litSymbol:}
|     ""<:"" ""#""<name>  "">""							{#bsMeta:}
|     ""<meta:"" ""#""<name>  "">""						{#bsMeta:}												
|	""#"" ""["" ByteArray ""]""							{#litArray:}
|	""#"" ""("" LiteralArray "")""						{#litArray:}
|	""#:""											{#litString:};


ByteArray:
												{#byteStream}
|	ByteArray <number>							{#byteStreamPut:};

LiteralArray:
												{#stream}
|	LiteralArray ArrayLiteral					{#streamPut:};

ArrayLiteral:
	Literal										{#value:}
|	<name>										{#valueSymbol:}
|	<binarySymbol>								{#valueSymbol:}
|	<keyword>									{#valueSymbol:}
|	<multikeyword>								{#valueSymbol:}
|	<alternateKeyword>							{#valueSymbol:}
|	""("" LiteralArray "")""							{#contents2:}
|	""["" ByteArray ""]""							{#contents2:}
|	<anyChar>									{#valueSymbol:};

PrimitiveMessage:
	| PrimitiveMessage <keyword>
	| PrimitiveMessage Literal
	| PrimitiveMessage ""(""
	| PrimitiveMessage "")""
	| PrimitiveMessage ""{""
	| PrimitiveMessage ""}""
	| PrimitiveMessage "";""
	| PrimitiveMessage <period>
	| PrimitiveMessage <name>
	| PrimitiveMessage <binarySymbol>;
"! !

!ByteSurgeonParser class methodsFor: 'bytesurgeon' stamp: 'md 6/29/2005 13:57'!
parseStringForInlining: aString

	^self parseStringForInlining: aString inliner: nil.! !

!ByteSurgeonParser class methodsFor: 'bytesurgeon' stamp: 'md 9/12/2005 11:59'!
parseStringForInlining: aString inliner: anInliner

	| ir  |
	ir := (self parseDoIt: aString) generateIRForInlining: anInliner.
	^ ir removeReturn removeEmptyStart startSequence. ! !

!ByteSurgeonParser class methodsFor: 'generated-accessing' stamp: 'md 10/4/2005 15:57'!
scannerClass
	^ByteSurgeonScanner! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 10/4/2005 15:57'!
startingStateForMethod
	^1! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 10/4/2005 15:57'!
startingStateForMethodPattern
	^3! !

!ByteSurgeonParser class methodsFor: 'generated-starting states' stamp: 'md 10/4/2005 15:57'!
startingStateForSequence
	^2! !

!ByteSurgeonParser methodsFor: 'reduction actions' stamp: 'md 6/10/2005 15:09'!
bsMeta: node
	^ByteSurgeonNode new 
				reify: node third value asSymbol.! !

!ByteSurgeonParser methodsFor: 'generated-reduction actions' stamp: 'md 10/4/2005 15:57'!
reduceActionForOptionalXXXperiodX1: nodes 
	^ nil! !

!ByteSurgeonParser methodsFor: 'generated-reduction actions' stamp: 'md 10/4/2005 15:57'!
reduceActionForOptionalXXXperiodX2: nodes 
	^ nodes  at:1! !

!ByteSurgeonParser methodsFor: 'generated-tables' stamp: 'md 10/4/2005 15:57'!
reduceTable
	^#(
#(36 0 #array)
#(36 2 #first:)
#(36 5 #returnAdd:)
#(36 3 #return:)
#(37 0 #array)
#(37 2 #add:)
#(38 1 #firstIn:)
#(38 3 #add3:)
#(39 0 #reduceActionForOptionalXXXperiodX1:)
#(39 1 #reduceActionForOptionalXXXperiodX2:)
#(40 1 #first:)
#(40 1 #first:)
#(40 1 #first:)
#(41 2 #secondIn:)
#(41 3 #add3:)
#(42 5 #blockWithArgs:)
#(42 3 #blockNoArgs:)
#(42 3 #blockArgs:)
#(42 7 #blockWithTemps:)
#(43 3 #assignment:)
#(44 1 #first:)
#(44 3 #cascade:)
#(45 3 #second:)
#(45 1 #first:)
#(45 1 #first:)
#(45 1 #first:)
#(45 1 #first:)
#(46 3 #array:)
#(47 1 #litTrue:)
#(47 1 #litFalse:)
#(47 1 #litNil:)
#(47 1 #litNumber:)
#(47 1 #litNumber:)
#(47 1 #litChar:)
#(47 1 #litString:)
#(47 2 #litStringSymbol:)
#(47 2 #litSymbol:)
#(47 2 #litSymbol:)
#(47 2 #litSymbol:)
#(47 2 #litSymbol:)
#(47 2 #litSymbol:)
#(47 4 #bsMeta:)
#(47 4 #bsMeta:)
#(47 4 #litArray:)
#(47 4 #litArray:)
#(47 1 #litString:)
#(48 1 #array)
#(48 3 #second:)
#(49 1 #first:)
#(49 1 #first:)
#(49 1 #first:)
#(50 2 #messagePart:)
#(50 3 #addMessagePart:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(52 2 #messageSend:)
#(52 2 #messageSend:)
#(52 2 #messageSend:)
#(53 2 #messageSend:)
#(53 2 #messageSend:)
#(54 1 #unaryMessage:)
#(55 2 #messagePart:)
#(56 2 #messagePart:)
#(56 3 #addMessagePart:)
#(57 1 #first:)
#(57 1 #first:)
#(57 1 #first:)
#(58 1 #first:)
#(58 1 #first:)
#(59 1 #variable:)
#(60 3 #primitiveMessage:)
#(61 1 #unaryMessage:)
#(61 2 #messagePart:)
#(61 1 #first:)
#(62 1 #sequence:)
#(62 2 #sequenceWithTemps:)
#(63 0 #byteStream)
#(63 2 #byteStreamPut:)
#(64 0 #stream)
#(64 2 #streamPut:)
#(65 1 #value:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 3 #contents2:)
#(65 3 #contents2:)
#(65 1 #valueSymbol:)
#(66 2 #method:)
#(66 3 #methodPrim:)
#(66 4 #methodTempsPrim:)
#(69 1 #first:)
#(69 1 #first:)
#(69 1 #first:)
#(70 1 #reduceFor:)
#(71 0 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
#(71 2 #reduceFor:)
)! !

!ByteSurgeonParser methodsFor: 'generated-tables' stamp: 'md 10/4/2005 15:57'!
transitionTable
	^#(
#(3 17 24 21 25 25 27 29 50 33 61 37 66)
#(3 41 1 45 3 49 4 53 8 57 9 61 10 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 113 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 49 157 51 161 52 165 53 169 59 173 62 6 67)
#(3 17 24 21 25 25 27 29 50 177 61)
#(2 294 1 3 4 6 8 9 10 12 13 15 16 17 18 20 21 22 23 24 32 67)
#(3 105 24 181 59)
#(3 105 24 185 59)
#(3 302 1 302 3 302 4 302 6 302 8 302 9 302 10 302 12 302 13 302 15 302 16 302 17 302 18 302 20 302 21 302 22 302 23 302 24 189 25 302 32 302 67)
#(3 41 1 45 3 49 4 193 6 53 8 57 9 61 10 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 113 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 197 48 153 49 157 51 161 52 165 53 169 59 201 60 205 62 6 67)
#(2 0 67)
#(3 41 1 6 2 45 3 49 4 209 5 53 8 57 9 61 10 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 113 36 117 38 121 40 213 41 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 49 157 51 161 52 165 53 169 59 217 62)
#(2 186 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(3 22 4 22 24 221 37)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 225 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 229 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(2 190 1 2 3 6 8 9 12 13 15 16 17 18 20 21 22 23 24 32 67)
#(3 233 1 237 9 241 23 245 24 249 25 253 26 257 27 261 29)
#(2 265 12)
#(2 126 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 269 12)
#(2 122 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(3 41 1 45 3 53 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 6 19 89 20 93 21 97 22 101 23 105 24 109 32 273 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(2 118 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 130 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 134 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 142 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 286 1 2 3 4 5 6 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 28 32 33 67)
#(2 138 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 306 2 67)
#(3 38 2 38 19 277 33 281 39 38 67)
#(2 30 2 19 33 67)
#(2 102 2 11 14 19 24 25 27 33 67)
#(2 46 2 11 19 33 67)
#(3 50 2 50 11 285 14 50 19 50 33 50 67)
#(3 54 2 54 11 54 19 289 24 293 25 297 27 54 33 301 54 305 55 309 56 54 67)
#(2 98 2 11 14 19 24 25 27 33 67)
#(2 106 2 11 14 19 24 25 27 33 67)
#(3 41 1 6 2 45 3 53 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 313 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59 6 67)
#(2 86 2 11 14 19 33 67)
#(2 198 2 11 14 19 33 67)
#(3 202 2 202 11 202 14 202 19 293 25 297 27 202 33 317 55 321 56 202 67)
#(3 206 2 206 11 206 14 206 19 289 24 293 25 297 27 206 33 325 54 329 55 333 56 206 67)
#(3 110 2 110 11 110 19 110 24 110 25 110 27 337 28 110 33 110 67)
#(2 0 67)
#(2 0 67)
#(2 210 1 3 4 6 8 9 10 12 13 15 16 17 18 20 21 22 23 24 25 32 67)
#(2 298 1 3 4 6 8 9 10 12 13 15 16 17 18 20 21 22 23 24 32 67)
#(3 105 24 341 59)
#(3 394 3 394 7 394 9 394 11 394 12 394 13 394 14 394 15 394 16 394 17 394 18 394 19 394 20 394 21 394 22 394 23 394 24 394 25 394 27 394 32 394 33 345 71)
#(3 41 1 45 3 193 6 53 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 313 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59 349 60 6 67)
#(3 41 1 45 3 49 4 53 8 57 9 61 10 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 113 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 49 157 51 161 52 165 53 169 59 353 62 6 67)
#(2 366 67)
#(3 105 24 357 59)
#(3 361 2 365 4 369 5 373 10)
#(2 377 2)
#(3 381 4 105 24 385 59)
#(3 38 2 38 19 389 33 393 39 38 67)
#(2 397 11)
#(3 314 2 314 21 401 63)
#(3 322 1 322 3 322 9 322 11 322 12 322 13 322 15 322 16 322 17 322 20 322 21 322 22 322 23 322 24 322 25 322 26 322 27 322 29 322 32 322 35 405 64)
#(2 146 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 150 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 158 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 162 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 154 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 166 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 409 24)
#(2 413 24)
#(2 417 19)
#(3 41 1 42 2 45 3 421 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 42 19 89 20 93 21 97 22 101 23 105 24 109 32 425 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59 42 67)
#(2 10 2 19 67)
#(3 289 24 293 25 297 27 429 54 433 55 437 56 441 69)
#(2 250 2 11 14 19 24 25 27 33 67)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 125 42 445 45 141 46 145 47 449 52 453 53 457 57 461 59)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 125 42 465 45 141 46 145 47 469 53 473 58 461 59)
#(2 246 2 11 14 19 24 25 27 33 67)
#(2 238 2 11 14 19 25 27 33 67)
#(3 226 2 226 11 226 14 226 19 477 25 226 33 226 67)
#(2 310 2 67)
#(2 230 2 11 14 19 25 27 33 67)
#(3 218 2 218 11 218 14 218 19 477 25 218 33 218 67)
#(2 242 2 11 14 19 24 25 27 33 67)
#(2 234 2 11 14 19 25 27 33 67)
#(3 222 2 222 11 222 14 222 19 477 25 222 33 222 67)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 481 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(2 214 1 3 4 6 8 9 10 12 13 15 16 17 18 20 21 22 23 24 25 32 67)
#(3 45 3 485 7 489 9 493 11 65 12 69 13 497 14 73 15 77 16 81 17 501 18 505 19 89 20 93 21 97 22 101 23 509 24 513 25 517 27 109 32 521 33 525 47)
#(3 41 1 45 3 53 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 529 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59 6 67)
#(2 370 67)
#(2 58 2 4 5 10)
#(2 74 2 11 14 19 24 25 27 33 67)
#(3 41 1 6 2 45 3 49 4 53 8 57 9 61 10 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 113 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 149 48 153 49 157 51 161 52 165 53 169 59 533 62)
#(3 105 24 537 59)
#(3 22 4 22 24 541 37)
#(2 70 2 11 14 19 24 25 27 33 67)
#(2 194 1 2 3 6 8 9 12 13 15 16 17 18 20 21 22 23 24 32 67)
#(2 26 4 24)
#(2 42 2 19 67)
#(2 18 2 19 67)
#(2 94 2 11 14 19 24 25 27 33 67)
#(3 545 2 549 21)
#(3 553 1 45 3 557 9 561 11 65 12 69 13 73 15 77 16 81 17 89 20 93 21 97 22 101 23 565 24 569 25 573 26 577 27 581 29 109 32 585 35 589 47 593 65)
#(2 597 7)
#(2 601 7)
#(2 114 2 11 14 19 24 25 27 33 67)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 605 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(2 34 2 19 33 67)
#(2 378 2 11 14 19 33 67)
#(2 382 2 11 14 19 33 67)
#(3 386 2 386 11 386 14 386 19 477 25 386 33 386 67)
#(2 90 2 11 14 19 33 67)
#(3 274 2 274 11 274 14 274 19 289 24 274 25 297 27 274 33 301 54 305 55 274 67)
#(3 266 2 266 11 266 14 266 19 266 25 297 27 266 33 317 55 266 67)
#(3 270 2 270 11 270 14 270 19 289 24 270 25 297 27 270 33 325 54 329 55 270 67)
#(2 258 2 11 14 19 25 33 67)
#(2 110 2 11 14 19 24 25 27 33 67)
#(3 282 2 282 11 282 14 282 19 289 24 282 25 282 27 282 33 301 54 282 67)
#(3 278 2 278 11 278 14 278 19 289 24 278 25 278 27 278 33 325 54 278 67)
#(2 254 2 11 14 19 25 27 33 67)
#(3 41 1 45 3 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 125 42 445 45 141 46 145 47 449 52 453 53 609 57 461 59)
#(2 82 2 11 19 33 67)
#(2 290 1 3 4 8 9 10 12 13 15 16 17 18 20 21 22 23 24 32 67)
#(2 406 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 410 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 422 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 414 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 418 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 430 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 398 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 434 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 426 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 402 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 27 32 33)
#(2 374 67)
#(2 613 2)
#(2 62 2 4 5 10)
#(3 617 4 105 24 385 59)
#(2 178 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 318 2 21)
#(3 314 2 314 21 621 63)
#(3 322 1 322 3 322 9 322 11 322 12 322 13 322 15 322 16 322 17 322 20 322 21 322 22 322 23 322 24 322 25 322 26 322 27 322 29 322 32 322 35 625 64)
#(2 182 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 334 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 342 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 346 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 338 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 350 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 362 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 330 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 326 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 170 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(2 174 1 2 3 7 9 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 29 32 33 35 67)
#(3 38 2 38 19 389 33 629 39 38 67)
#(2 262 2 11 14 19 25 33 67)
#(2 66 2 11 14 19 24 25 27 33 67)
#(3 41 1 6 2 45 3 53 8 57 9 65 12 69 13 73 15 77 16 81 17 85 18 89 20 93 21 97 22 101 23 105 24 109 32 633 36 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 47 153 49 157 51 161 52 165 53 169 59)
#(3 637 2 549 21)
#(3 553 1 45 3 557 9 641 11 65 12 69 13 73 15 77 16 81 17 89 20 93 21 97 22 101 23 565 24 569 25 573 26 577 27 581 29 109 32 585 35 589 47 593 65)
#(2 14 2 19 67)
#(2 645 2)
#(2 358 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 354 1 3 9 11 12 13 15 16 17 20 21 22 23 24 25 26 27 29 32 35)
#(2 78 2 11 14 19 24 25 27 33 67)
)! !

SqueakScanner subclass: #ByteSurgeonScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!ByteSurgeonScanner commentStamp: '<historical>' prior: 0!
Modified Scanner for Bytesurgeon: This adds support for <ARGS: aNumber> access to unamed arguments!

!ByteSurgeonScanner class methodsFor: 'generated-initialization' stamp: 'md 10/4/2005 15:57'!
initializeKeywordMap
	keywordMap _ Dictionary new.
	#(#(24 'false' 17 ) #(24 'nil' 15 ) #(24 'true' 20 ) )  do:
				[:each | 
				(keywordMap  at:each first  ifAbsentPut:[Dictionary new])  at:(each  at:2)
					 put:each last].
	^ keywordMap! !

!ByteSurgeonScanner class methodsFor: 'generated-comments' stamp: 'md 10/4/2005 15:57'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<scaledNumber>:		<decimalNumber> s [0-9]+ ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> | <scaledNumber> ;
<negativeNumber>:	\- <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\-\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: \= | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<period>:				\. ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';')
"! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
binarySymbolId
	^27! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
emptySymbolTokenId
	^67! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
errorTokenId
	^68! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
nameId
	^24! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
negativeNumberId
	^22! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
numberId
	^21! !

!ByteSurgeonScanner methodsFor: 'generated-tokens' stamp: 'md 10/4/2005 15:57'!
periodId
	^33! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan1
	self step.
	currentCharacter isDigit 
		 ifTrue:
			[
			[self  recordMatch:#(21 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter  ==$-  ifTrue:[^ self scan2].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan10
	self step.
	currentCharacter isDigit 
		 ifTrue:
			[
			[self  recordMatch:#(21 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter  ==$e  ifTrue:[^ self scan1].
			currentCharacter  ==$s  ifTrue:[^ self scan2].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan11
	self  recordMatch:#(25 ).
	self step.
	((currentCharacter  between:$A  and:$Z) 
		 or:[currentCharacter  between:$a  and:$z])  ifTrue:[^ self scan7].
	currentCharacter  ==$= 
		 ifTrue:[^ self  recordAndReportMatch:#variableAssignment].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan2
	self step.
	currentCharacter isDigit 
		 ifTrue:
			[
			[self  recordMatch:#(21 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan3
	self step.
	currentCharacter isDigit 
		 ifTrue:
			[
			[self  recordMatch:#(22 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan4
	self step.
	currentCharacter isDigit 
		 ifTrue:
			[
			[self  recordMatch:#(22 ).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^ self reportLastMatch].
	currentCharacter  ==$-  ifTrue:[^ self scan3].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan5
	self  recordMatch:#(23 ).
	self step.
	currentCharacter  ==$'  ifTrue:[^ self scan6].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan6
	
	[self step.
	currentCharacter  ~~$'] whileTrue.
	^ self scan5! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan7
	
	[self step.
	currentCharacter isDigit  or:
			[(currentCharacter  between:$A  and:$Z) 
				 or:[currentCharacter  between:$a  and:$z]]] 
			whileTrue.
	currentCharacter  ==$: 
		 ifTrue:
			[self  recordMatch:#(26 ).
			self step.
			((currentCharacter  between:$A  and:$Z) 
				 or:[currentCharacter  between:$a  and:$z])  ifTrue:[^ self scan7].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan8
	
	[self step.
	currentCharacter isDigit  or:
			[(currentCharacter  between:$A  and:$Z) 
				 or:[currentCharacter  between:$a  and:$z]]] 
			whileTrue.
	currentCharacter  ==$: 
		 ifTrue:
			[self  recordMatch:#(29 ).
			self step.
			((currentCharacter  between:$A  and:$Z) 
				 or:[currentCharacter  between:$a  and:$z])  ifTrue:[^ self scan8].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scan9
	self step.
	(currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]) 
		 ifTrue:
			[
			[self  recordMatch:#(21 ).
			self step.
			currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]] 
					whileTrue.
			currentCharacter  ==$. 
				 ifTrue:
					[self step.
					(currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]) 
						 ifTrue:
							[
							[self  recordMatch:#(21 ).
							self step.
							currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]] 
									whileTrue.
							currentCharacter  ==$e  ifTrue:[^ self scan1].
							^ self reportLastMatch].
					^ self reportLastMatch].
			currentCharacter  ==$e  ifTrue:[^ self scan1].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!ByteSurgeonScanner methodsFor: 'generated-scanner' stamp: 'md 10/4/2005 15:57'!
scanForToken
	self step.
	(currentCharacter  <=$  or:
			[(currentCharacter  between:$  and:$) 
				 or:[currentCharacter  ==$`  or:[currentCharacter  >=$]]]) 
		 ifTrue:[^ self  recordAndReportMatch:#(35 )].
	((currentCharacter  between:$A  and:$Z) 
		 or:[currentCharacter  between:$a  and:$z]) 
			 ifTrue:
				[self  recordMatch:#(24 35 ).
				self step.
				(currentCharacter isDigit  or:
						[(currentCharacter  between:$A  and:$Z) 
							 or:[currentCharacter  between:$a  and:$z]]) 
					 ifTrue:
						[
						[self  recordMatch:#(24 ).
						self step.
						currentCharacter isDigit  or:
								[(currentCharacter  between:$A  and:$Z) 
									 or:[currentCharacter  between:$a  and:$z]]] 
								whileTrue.
						currentCharacter  ==$:  ifTrue:[^ self scan11].
						^ self reportLastMatch].
				currentCharacter  ==$:  ifTrue:[^ self scan11].
				^ self reportLastMatch].
	(currentCharacter  ==$!!  or:
			[(currentCharacter  between:$%  and:$&)  or:
					[(currentCharacter  between:$*  and:$,)  or:
							[currentCharacter  ==$/  or:
									[currentCharacter  ==$=  or:
											[(currentCharacter  between:$?  and:$@) 
												 or:[currentCharacter  ==$\  or:[currentCharacter  ==$~]]]]]]]) 
		 ifTrue:
			[self  recordMatch:#binarySymbol.
			self step.
			currentCharacter isSpecial 
				 ifTrue:
					[
					[self  recordMatch:#binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter isDigit 
		 ifTrue:
			[self  recordMatch:#(21 35 ).
			self step.
			currentCharacter isDigit 
				 ifTrue:
					[
					[self  recordMatch:#(21 ).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter  ==$.  ifTrue:[^ self scan10].
					currentCharacter  ==$e  ifTrue:[^ self scan1].
					currentCharacter  ==$r  ifTrue:[^ self scan9].
					currentCharacter  ==$s  ifTrue:[^ self scan2].
					^ self reportLastMatch].
			currentCharacter  ==$.  ifTrue:[^ self scan10].
			currentCharacter  ==$e  ifTrue:[^ self scan1].
			currentCharacter  ==$r  ifTrue:[^ self scan9].
			currentCharacter  ==$s  ifTrue:[^ self scan2].
			^ self reportLastMatch].
	(currentCharacter isSeparator  or:[currentCharacter  ==$]) 
		 ifTrue:
			[self  recordMatch:#whitespace.
			self step.
			(currentCharacter isSeparator  or:[currentCharacter  ==$]) 
				 ifTrue:
					[
					[self  recordMatch:#whitespace.
					self step.
					currentCharacter isSeparator  or:[currentCharacter  ==$]] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter  ==$" 
		 ifTrue:
			[self  recordMatch:#(35 ).
			self step.
			currentCharacter  ~~$" 
				 ifTrue:
					[
					[self step.
					currentCharacter  ~~$"] whileTrue.
					^ self  recordAndReportMatch:#comment].
			currentCharacter  ==$"  ifTrue:[^ self  recordAndReportMatch:#comment].
			^ self reportLastMatch].
	currentCharacter  ==$# 
		 ifTrue:
			[self  recordMatch:#(12 35 ).
			self step.
			currentCharacter  ==$:  ifTrue:[^ self  recordAndReportMatch:#(3 )].
			^ self reportLastMatch].
	currentCharacter  ==$$ 
		 ifTrue:
			[self  recordMatch:#(35 ).
			self step.
			^ self  recordAndReportMatch:#(32 )].
	currentCharacter  ==$' 
		 ifTrue:
			[self  recordMatch:#(35 ).
			self step.
			currentCharacter  ~~$'  ifTrue:[^ self scan6].
			currentCharacter  ==$'  ifTrue:[^ self scan5].
			^ self reportLastMatch].
	currentCharacter  ==$(  ifTrue:[^ self  recordAndReportMatch:#(9 35 )].
	currentCharacter  ==$)  ifTrue:[^ self  recordAndReportMatch:#(11 35 )].
	currentCharacter  ==$- 
		 ifTrue:
			[self  recordMatch:#binarySymbol.
			self step.
			currentCharacter isSpecial 
				 ifTrue:
					[
					[self  recordMatch:#binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter isDigit 
				 ifTrue:
					[
					[self  recordMatch:#(22 ).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter  ==$. 
						 ifTrue:
							[self step.
							currentCharacter isDigit 
								 ifTrue:
									[
									[self  recordMatch:#(22 ).
									self step.
									currentCharacter isDigit] 
											whileTrue.
									currentCharacter  ==$e  ifTrue:[^ self scan4].
									currentCharacter  ==$s  ifTrue:[^ self scan3].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter  ==$e  ifTrue:[^ self scan4].
					currentCharacter  ==$r 
						 ifTrue:
							[self step.
							(currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]) 
								 ifTrue:
									[
									[self  recordMatch:#(22 ).
									self step.
									currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]] 
											whileTrue.
									currentCharacter  ==$. 
										 ifTrue:
											[self step.
											(currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]) 
												 ifTrue:
													[
													[self  recordMatch:#(22 ).
													self step.
													currentCharacter isDigit  or:[currentCharacter  between:$A  and:$Z]] 
															whileTrue.
													currentCharacter  ==$e  ifTrue:[^ self scan4].
													^ self reportLastMatch].
											^ self reportLastMatch].
									currentCharacter  ==$e  ifTrue:[^ self scan4].
									^ self reportLastMatch].
							^ self reportLastMatch].
					currentCharacter  ==$s  ifTrue:[^ self scan3].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter  ==$.  ifTrue:[^ self  recordAndReportMatch:#(33 35 )].
	currentCharacter  ==$: 
		 ifTrue:
			[self  recordMatch:#(5 35 ).
			self step.
			((currentCharacter  between:$A  and:$Z) 
				 or:[currentCharacter  between:$a  and:$z])  ifTrue:[^ self scan8].
			currentCharacter  ==$=  ifTrue:[^ self  recordAndReportMatch:#(28 )].
			^ self reportLastMatch].
	currentCharacter  ==$;  ifTrue:[^ self  recordAndReportMatch:#(14 35 )].
	currentCharacter  ==$< 
		 ifTrue:
			[self  recordMatch:#(6 27 35 ).
			self step.
			currentCharacter isSpecial 
				 ifTrue:
					[
					[self  recordMatch:#binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter  ==$:  ifTrue:[^ self  recordAndReportMatch:#(13 )].
			currentCharacter  ==$m 
				 ifTrue:
					[self step.
					currentCharacter  ==$e 
						 ifTrue:
							[self step.
							currentCharacter  ==$t 
								 ifTrue:
									[self step.
									currentCharacter  ==$a 
										 ifTrue:
											[self step.
											currentCharacter  ==$:  ifTrue:[^ self  recordAndReportMatch:#(16 )].
											^ self reportLastMatch].
									^ self reportLastMatch].
							^ self reportLastMatch].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter  ==$> 
		 ifTrue:
			[self  recordMatch:#(7 27 35 ).
			self step.
			currentCharacter isSpecial 
				 ifTrue:
					[
					[self  recordMatch:#binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter  ==$[  ifTrue:[^ self  recordAndReportMatch:#(1 35 )].
	currentCharacter  ==$]  ifTrue:[^ self  recordAndReportMatch:#(2 35 )].
	currentCharacter  ==$^  ifTrue:[^ self  recordAndReportMatch:#(8 35 )].
	currentCharacter  ==$_  ifTrue:[^ self  recordAndReportMatch:#(28 35 )].
	currentCharacter  ==${  ifTrue:[^ self  recordAndReportMatch:#(18 35 )].
	currentCharacter  ==$| 
		 ifTrue:
			[self  recordMatch:#(4 27 35 ).
			self step.
			(currentCharacter  ==$!!  or:
					[(currentCharacter  between:$%  and:$&)  or:
							[(currentCharacter  between:$*  and:$-)  or:
									[currentCharacter  ==$/  or:
											[(currentCharacter  between:$<  and:$@) 
												 or:[currentCharacter  ==$\  or:[currentCharacter  ==$~]]]]]]) 
				 ifTrue:
					[
					[self  recordMatch:#binarySymbol.
					self step.
					currentCharacter isSpecial] 
							whileTrue.
					^ self reportLastMatch].
			currentCharacter  ==$| 
				 ifTrue:
					[self  recordMatch:#(10 27 ).
					self step.
					currentCharacter isSpecial 
						 ifTrue:
							[
							[self  recordMatch:#binarySymbol.
							self step.
							currentCharacter isSpecial] 
									whileTrue.
							^ self reportLastMatch].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter  ==$}  ifTrue:[^ self  recordAndReportMatch:#(19 35 )].
	^ self reportLastMatch! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 8/10/2005 12:12'!
genBlock: blockSeq to: cont
	| seq |
	seq := self newSeq.
	seq add: (IRInstruction pushThisContext).
	seq add: (IRInstruction pushLiteral: 0).
	seq add: (IRInstruction send: #blockCopy:).
	seq add: (IRInstruction jumpOverBlock: blockSeq to: cont).
	blockSeq setSuccessor: cont.

	^seq.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:08'!
insertAfter: aString
	self insertAfter: aString using: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
insertAfter: aString using: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self using: aDict.
	inliner insertAfter: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:09'!
insertBefore: aString
	self insertBefore: aString using: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
insertBefore: aString using: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self using: aDict.
	inliner insertBefore: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 9/23/2005 14:30'!
insertSequenceFrontNoPop: aSequence
	"aSequece is added at the front, fix aSequence to jump to the old startSequence."
	self removeEmptyStart.
	
	aSequence isEmpty ifTrue: [^self].
	aSequence withAllSuccessorsDo: [:succ | 
		succ notEmpty ifTrue: [ | last |
			last := succ last.
			last isJump 
				ifFalse: [last isReturn ifFalse: [
							succ addLast: (IRInstruction goto: self startSequence)]] 
				ifTrue: [last destination isEmpty ifTrue: [last destination: self startSequence]]].
	].
	self startSequence: aSequence.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 9/28/2005 17:21'!
insertSequenceFront: aSequence
	"aSequece is added at the front, fix aSequence to jump to the old startSequence."
	self removeEmptyStart.
	
	aSequence withAllSuccessorsDo: [:succ | 
		succ notEmpty ifTrue: [
			| last |
			last := succ last.
			last isJump ifFalse: [ 
					last isReturn ifFalse: [
						succ addLast: (IRInstruction popTop).
						succ addLast: (IRInstruction goto: self startSequence)]] 
				ifTrue: [
					last destination isEmpty ifTrue: [
						succ removeLast.
						last isReturn ifFalse: [succ addLast: (IRInstruction popTop)].
						succ addLast: (IRInstruction goto: self startSequence) 
						].
					"last destination: self startSequence"]	
				].
	].
	self startSequence: aSequence.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'dr 4/5/2005 20:12'!
originalMaxTemp
	^self compiledMethod numTmpVars
	! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:10'!
replace: aString
	self replace: aString using: nil.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
replace: aString using: aDict
	| inliner |
	inliner :=  IRInlinerMethod on: self using: aDict.
	inliner replace: aString.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
selector
	selector ifNil: [selector := compiledMethod selector].
	^selector.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 7/29/2005 09:27'!
strip
	self removeEmptyStart removeReturnSelf! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:38'!
tempVarNameForOffset: offset
	^compiledMethod tempVarNameForOffset: offset.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 6/21/2005 13:44'!
updateSequenceNumbers
	IRNumberer on: self.! !

!IRMethod methodsFor: '*bytesurgeon' stamp: 'md 9/28/2005 17:44'!
wrapInEnsure: aSeq
	| toBeWrapped ensureSeq blockHead1 blockHead2 ensure |

	self removeEmptyStart.
	
	toBeWrapped := self startSequence tranformToBlockSequence.
	ensureSeq := aSeq tranformToBlockSequence.
	ensure := self newSeq.
	ensure add: (IRInstruction send: #ensure:).
	ensure add: (IRInstruction returnTop).
	
	blockHead2 := self genBlock: ensureSeq to: ensure.
	blockHead1 := self genBlock: toBeWrapped to: blockHead2.

	self startSequence: blockHead1.

	self updateSequenceNumbers.
	^ensureSeq.
! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
insertAfter: aString using: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self using: aDict.
	inliner insertAfter: aString.! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
insertBefore: aString using: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self using: aDict.
	inliner insertBefore: aString.! !

!IRSend methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
replace: aString using: aDict
	| inliner |
	inliner :=  IRInlinerSend on: self using: aDict.
	inliner replace: aString.! !

ASTTranslator subclass: #BSASTTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!BSASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'md 6/29/2005 12:19'!
acceptDoItNode: aDoItNode 
	| scope |

	methodBuilder numRargs: 1.
	methodBuilder addTemps: #(self 1 2 3 4 5 6 7 8 9 10 11 12 13
							14 15 16 17 18 19 20 21 22 23).
	aDoItNode byteSurgeon: true.
	scope :=  aDoItNode scope.
	methodBuilder addTemps: scope tempVars.
	aDoItNode scope emitPrologue: methodBuilder.
	valueTranslator visitNode: aDoItNode body.
	aDoItNode body lastIsReturn ifFalse: [
		methodBuilder returnTop].! !

!BSASTTranslator methodsFor: 'initialize' stamp: 'md 2/25/2005 12:27'!
initialize

	methodBuilder := IRBuilder new.
	effectTranslator := self as: ASTTranslatorForEffect.
	valueTranslator := self as: BSASTTranslatorForValue.
	effectTranslator instVarNamed: #effectTranslator put: effectTranslator.
	effectTranslator instVarNamed: #valueTranslator put: valueTranslator.
	valueTranslator instVarNamed: #valueTranslator put: valueTranslator.
! !

!BSASTTranslator methodsFor: 'initialize' stamp: 'md 6/16/2005 13:57'!
inliner: anInliner
	valueTranslator inliner: anInliner.! !

!IRTempAccess methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:56'!
varname
	name ifNil: [name := self method compiledMethod tempVarNameForOffset: self offset].
	^name.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:08'!
instrumentAll: aBlockCollection
	super instrumentAll: aBlockCollection.
	self class instrumentAll: aBlockCollection.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentConstant:  aBlock
	super instrumentConstant:  aBlock.
	self class instrumentConstant: aBlock.! !

!Class methodsFor: '*bytesurgeon-experimental' stamp: 'abc 10/26/2005 11:56'!
instrumentFromCode: aBlock
	super instrumentFromCode: aBlock.
	self class instrumentFromCode: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarAccess:  aBlock
	super instrumentInstVarAccess:  aBlock.
	self class instrumentInstVarAccess: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarRead:  aBlock
	super instrumentInstVarRead:  aBlock.
	self class instrumentInstVarRead: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:05'!
instrumentInstVarStore:  aBlock
	super instrumentInstVarStore:  aBlock.
	self class instrumentInstVarStore: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentSend:  aBlock
	super instrumentSend:  aBlock.
	self class instrumentSend: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempAccess:  aBlock
	super instrumentTempAccess:  aBlock.
	self class instrumentTempAccess: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempRead:  aBlock
	super instrumentTempRead:  aBlock.
	self class instrumentTempRead: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:06'!
instrumentTempStore:  aBlock
	super instrumentTempStore:  aBlock.
	self class instrumentTempStore: aBlock.! !

!Class methodsFor: '*bytesurgeon' stamp: 'md 6/29/2005 17:05'!
instrument: aBlock
	super instrument: aBlock.
	self class instrument: aBlock.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:45'!
bsTempNames
	"Answer an OrderedCollection of the names of the receiver's temporary 
	variables, which are strings."

	"unused temps at end are not included in method. On the other hand, extra temps such as to:do: loop limit are added to method"
	| tempNames n |
	tempNames := self methodNode tempNames.
	n := self numTemps.
	tempNames size = n ifTrue: [^ tempNames].
	tempNames size > n ifTrue: [^ tempNames first: n].
	tempNames size + 1 to: n do: [:i |
		tempNames := tempNames copyWith: 't' , i printString].
	^ tempNames! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:52'!
flagByteSurgeon
	self setProperty: #bytesurgeon toValue: true.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/20/2005 12:21'!
genAndReplaceMyselfWith: ir
	| new |
	new := ir compiledMethodWith: self trailer.
	new numTmpVars: self numTmpVars.	
	"new isByteSurgeon ifFalse: [new setProperty: #bsMethod toValue: self].	"	
	new flagByteSurgeon.
	self replaceMyselfWith: new.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:07'!
insertAfter: aString
	self insertAfter: aString using: nil! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:08'!
insertAfter: aStringOrBlockOrCollection using: dict
	| ir |
	ir := self ir insertAfter: aStringOrBlockOrCollection using: dict.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:09'!
insertBefore: aString
	self insertBefore: aString using: nil.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/10/2005 09:23'!
insertBefore: before after: after
	
	| ir |
	ir := (self ir insertBefore: before) insertAfter: after.
	self genAndReplaceMyselfWith: ir.

	! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:09'!
insertBefore: aStringOrBlockOrCollection using: dict
	
	| ir |
	ir := self ir insertBefore: aStringOrBlockOrCollection using: dict.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/5/2005 16:58'!
instrumentAll: aBlockCollection
	
	| ir instr |
	ir := self ir.
	instr := (ir allInstructionsMatching: [:t | true]).
	(instr select: [:each | each isSend not or: [each selector ~= #blockCopy:]]) do: [:each | 
			aBlockCollection do: [:block | block value: each]].
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/12/2005 00:34'!
instrumentConstant: aBlock

	self instrument: aBlock matching: [:instr | instr isConstant].! !

!CompiledMethod methodsFor: '*bytesurgeon-experimental' stamp: 'md 10/26/2005 10:17'!
instrumentFromCode: aBlock
	| ir instr ast |
	self flag: #fixme.
	ast := self rbAST.
	ast verifyIn: (self valueOfProperty: #class).
	ir :=  ast ir.
	
	ir setProperty: #class toValue: (self valueOfProperty: #class).
	ir setProperty: #selector toValue: (self valueOfProperty: #selector).
	"this should be done earlier when compiling to AST and then copied to
	IR. but good enough for now"
	
	
	

	instr := ir allInstructionsMatching:  [:t | true].
	(instr select: [:each | each isSend not or: [each selector ~= #blockCopy:]]) do: aBlock.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:19'!
instrumentInstVarAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarAccess].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:19'!
instrumentInstVarRead: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarRead].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:28'!
instrumentInstVarStore: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarStore].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:56'!
instrumentLiteralVariableAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableAccess].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:56'!
instrumentLiteralVariableRead: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableRead].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:56'!
instrumentLiteralVariableStore: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableStore].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:44'!
instrumentSend: aBlock
	self instrument: aBlock matching: [:instr | instr isSend].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:05'!
instrumentTempAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isTempAccess].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:43'!
instrumentTempRead: aBlock
	self instrument: aBlock matching: [:instr | instr isTempRead].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:28'!
instrumentTempStore: aBlock
	self instrument: aBlock matching: [:instr | instr isTempStore].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:42'!
instrument: aBlock
	self instrument: aBlock matching: [:instr | true].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 14:33'!
instrument: aBlock matching: aMatchBlock
	| ir instr |
	self flag: #fixme.
	ir := self ir.
	instr := ir allInstructionsMatching: aMatchBlock.
	(instr select: [:each | each isSend not or: [each selector ~= #blockCopy:]]) do: aBlock.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:30'!
isByteSurgeon
	^self valueOfProperty: #bytesurgeon ifAbsent: [false].! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
methodNode
	^ self method homeMethodNodeDecompileClass: self definitionClass selector: self selector.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:53'!
numTmpVars
	"Answer number of temps of self. 
	This information is stored in the property #origTempNum
	Because this method does not read the byte code to count the number of temps. one always gets the original number
	of temps, even ByteSurgeon has added some tmps later on."

	self isByteSurgeon ifFalse: [^self numTemps].
	^self valueOfProperty: #origTempNum.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 15:53'!
numTmpVars: num
	self setProperty: #origTempNum toValue: num.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 9/1/2005 20:38'!
rbAST
	^SqueakParser parseMethod: (self definitionClass sourceCodeAt: self selector).! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/9/2005 14:12'!
recompile
	"recompile the method from source. Works only if who can find out the
      class/selector"
	
	self definitionClass recompile: self selector.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/20/2005 09:10'!
replaceMyselfWith: method
	self definitionClass addSelectorSilently: self selector withMethod: method. ! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:10'!
replace: aString
	self replace: aString using: nil.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:10'!
replace: aString using: dict
	| ir |
	ir := self ir replace: aString using: dict.
	self genAndReplaceMyselfWith: ir.! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 10/1/2005 14:11'!
sourceRangeFor: pc
    "Answer the indices in the source code for the method corresponding to
    the selected context's program counter value."

    | i  ast sourceMap |
    ast := self rbAST.
    ast verifyIn: self definitionClass.
    sourceMap _ ast sourceMap.

    i _ sourceMap findLast: [:pcRange | pcRange key <= pc].
    i = 0 ifTrue:[^ 1 to: 0].
    ^ (sourceMap at: i) value
   ! !

!CompiledMethod methodsFor: '*bytesurgeon' stamp: 'md 7/21/2005 12:15'!
uninstallByteSurgeon
	| orig |
	self isByteSurgeon ifFalse: [^self].

	orig := self valueOfProperty: #bsMethod.
	self replaceMyselfWith: orig.
	self flag: #fixme
	" need to reset the properties"! !

!RBDoItNode methodsFor: '*bytesurgeon' stamp: 'md 6/16/2005 13:58'!
generateIRForInlining: inliner

	^ ir := BSASTTranslator new
		inliner: inliner;
		visitNode: self;
		ir! !

IRInterpreter subclass: #IRStackAnalyzer
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!IRStackAnalyzer commentStamp: 'md 7/19/2005 18:12' prior: 0!
I interpret IRMethods or just a sequence of IRInstructions and record stack-effects. 
I return the number of items pushed on the stack. This is usefull if you need to
balance the stack after e.g., inlining code at some point in a method.!

!IRStackAnalyzer class methodsFor: 'instance creation' stamp: 'md 2/27/2005 17:40'!
analyzeIR: anIRMethod
	^(self new interpret: anIRMethod) stack.! !

!IRStackAnalyzer class methodsFor: 'instance creation' stamp: 'md 2/27/2005 17:40'!
analyzeNodes: aCollectionOfNodes
	^(self new interpretNodes: aCollectionOfNodes) stack.! !

!IRStackAnalyzer methodsFor: 'initialize-release' stamp: 'md 2/22/2005 12:21'!
initialize
	stack := 0.! !

!IRStackAnalyzer methodsFor: 'interpret' stamp: 'md 2/27/2005 17:35'!
interpretNodes: instructionSequence

	instructionSequence do: [:instr | self interpretInstruction: instr].
! !

!IRStackAnalyzer methodsFor: 'stack' stamp: 'md 2/22/2005 12:22'!
pop
	stack := stack - 1.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 2/22/2005 12:21'!
popTop
	self pop.! !

!IRStackAnalyzer methodsFor: 'stack' stamp: 'md 2/22/2005 12:22'!
push
	stack := stack + 1.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 2/22/2005 12:23'!
pushDup
	self push.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 7/13/2005 14:54'!
pushInstVar: t
	self push.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 7/13/2005 13:59'!
pushLiteralVariable: t
	self push.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 2/22/2005 12:23'!
pushLiteral: t
	self push.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 2/22/2005 12:23'!
pushTemp: index
	self push.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 7/13/2005 17:22'!
returnTop
	stack := 0.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 7/22/2005 11:19'!
send: selector
	selector numArgs timesRepeat: [self pop].
	self pop. "receiver"
	self push. "result"! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 2/22/2005 13:29'!
send: selector toSuperOf: t
	selector numArgs timesRepeat: [self pop].
	self pop. "receiver"
	self push. "result"! !

!IRStackAnalyzer methodsFor: 'accessing' stamp: 'md 2/27/2005 17:33'!
stack
	^stack.! !

!IRStackAnalyzer methodsFor: 'instructions' stamp: 'md 7/13/2005 14:54'!
storeInstVar: t! !

ASTTranslatorForValue subclass: #BSASTTranslatorForValue
	instanceVariableNames: 'inliner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ByteSurgeon-Compiler'!

!BSASTTranslatorForValue methodsFor: 'visiting' stamp: 'md 6/23/2005 16:02'!
acceptByteSurgeonNode: aNode
	methodBuilder pushTemp: (inliner  getOffsetForName: aNode reify).! !

!BSASTTranslatorForValue methodsFor: 'accessing' stamp: 'md 6/16/2005 13:57'!
inliner: anInliner
	inliner := anInliner! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:06'!
insertAfter: aString using: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self using: aDict.
	inliner insertAfter: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:06'!
insertBefore: aString using: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self using: aDict.
	inliner insertBefore: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:08'!
offset
	^number! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 7/1/2005 11:30'!
replaceAndStore: aString 
	self replaceAndStore: aString with: nil.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:06'!
replaceAndStore: aString using: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self using: aDict.
	inliner replaceAndStore: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:02'!
replaceAndStore: aString with: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self using: aDict.
	inliner replaceAndStore: aString.! !

!IRAccess methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:06'!
replace: aString using: aDict
	| inliner |
	inliner :=  IRInlinerAccess on: self using: aDict.
	inliner replace: aString.! !

!MethodContext methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 14:52'!
tempVarNameForOffset: num
	^self tempNames at: num.! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/7/2005 16:47'!
instrumentAll: aBlockCollection
	self methodDict values copy do: [ :method |
		method instrumentAll: aBlockCollection
	].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentConstant: aBlock
	self instrument: aBlock matching: [:instr | instr isConstant].

! !

!Behavior methodsFor: '*bytesurgeon-experimental' stamp: 'md 10/24/2005 20:13'!
instrumentFromCode: aBlock
	self methodDict values copy do: [ :method |
		method instrumentFromCode: aBlock.
	].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:14'!
instrumentInstVarAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarAccess].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:14'!
instrumentInstVarRead: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarRead].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:05'!
instrumentInstVarStore: aBlock
	self instrument: aBlock matching: [:instr | instr isInstVarStore].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:57'!
instrumentLiteralVariableAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableAccess].! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:57'!
instrumentLiteralVariableRead: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableRead].! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:57'!
instrumentLiteralVariableStore: aBlock
	self instrument: aBlock matching: [:instr | instr isLiteralVariableStore].! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentSend: aBlock
	self instrument: aBlock matching: [:instr | instr isSend].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 11:04'!
instrumentTempAccess: aBlock
	self instrument: aBlock matching: [:instr | instr isTempAccess].

! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:48'!
instrumentTempRead: aBlock
	self instrument: aBlock matching: [:instr | instr isTempRead].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 12:06'!
instrumentTempStore: aBlock
	self instrument: aBlock matching: [:instr | instr isTempStore].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 6/13/2005 10:47'!
instrument: aBlock
	self instrument: aBlock matching: [:instr | true].! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/7/2005 16:40'!
instrument: aBlock matching: aMatchBlock
	self methodDict values copy do: [ :method |
		method instrument: aBlock matching: aMatchBlock.
	].
! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/15/2005 23:17'!
instVarNameForOffset: offset
	^self allInstVarNames at: offset.! !

!Behavior methodsFor: '*bytesurgeon' stamp: 'md 7/20/2005 09:17'!
uninstallByteSurgeon
		self methodDict values copy do: [:meth |
		meth uninstallByteSurgeon
	]
	! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'dr 4/7/2005 20:08'!
evaluate: aBlock
	^aBlock value: self! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:08'!
insertAfter: aString
	self insertAfter: aString using: nil.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:03'!
insertAfter: aString using: aDict
	| inliner |
	inliner :=  IRInliner on: self using: aDict.
	inliner insertAfter: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:09'!
insertBefore: aString
	self insertBefore: aString using: nil. ! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:03'!
insertBefore: aString using: aDict
	| inliner |
	inliner :=  IRInliner on: self using: aDict.
	inliner insertBefore: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:10'!
replace: aString
	self replace: aString using: nil.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 10/4/2005 16:04'!
replace: aString using: aDict
	| inliner |
	inliner :=  IRInliner on: self using: aDict.
	inliner replace: aString.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 6/23/2005 12:26'!
selector
	^self method selector.! !

!IRInstruction methodsFor: '*bytesurgeon' stamp: 'md 9/1/2005 20:48'!
sourceRange
    | bcOffset |
    bcOffset :=  self bytecodeOffset.
    ^self method compiledMethod sourceRangeFor: bcOffset.
! !
ByteSurgeon initialize!
